<?php
/* *********************************************** *
 * KVM Common Variables, Functions here
 * vesion :
 * Author : Jeong Huiju
 * *********************************************** */
error_reporting(E_ERROR);
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_start.php';

/* ****************** *
 * Initialization
 * ****************** */
$_www_path =
  (!isset($_SERVER['DOCUMENT_ROOT']) || $_SERVER['DOCUMENT_ROOT'] == "" || $_SERVER['DOCUMENT_ROOT'] == NULL) ?
    "/opt/www/" : $_SERVER['DOCUMENT_ROOT'];

//DB파일이 존재하면 class호출, 아니라면 초기화 DB복사하고 다시 기기 설정


/* ****************** *
 * Common Variables
 * ****************** */
if(strpos($_SERVER['SERVER_SOFTWARE'],"Win")){
  $_istreamer_config_file = "/work/kvm/ini/istreamer.ini";
  $_eraser_config_file = "/work/kvm/ini/eraser.ini";

  $_dns_server_file = "/work/kvm/ini/dns.ini";
  $_network_config_file = "/work/kvm/ini/net.ini";
  $_httpd_config_file = "/work/kvm/ini/httpd.ini";

  $_firmware_version_file = "/work/kvm/ini/version.ini";
  $_firmware_update_config_file = "/work/kvm/ini/update.ini";
  $_firmware_update_flag_file = "/work/kvm/ini/update";

  $_db_path_settings = "D:/work/kvm/database/settings.DB3";
  $_db_path_logs = "D:/work/kvm/database/logs.DB3";
  $_db_path_records = "D:/work/kvm/database/record.DB3";

  $_init_dir = $_SERVER['DOCUMENT_ROOT']."/files/init/";

  $_rview_setting_file = "/work/kvm/ini/rview.ini";
}
else{
  $_istreamer_config_file = "/etc/istreamer.conf";
  $_eraser_config_file = "/etc/eraser.ini";

  $_httpd_config_file = "/etc/lighttpd/lighttpd.conf";
  $_network_config_file = "/etc/network/ifcfg-eth0";
  $_dns_server_file = "/etc/resolv.conf";

  $_firmware_version_file = "/etc/version";
  $_firmware_update_config_file = "/etc/update.conf";
  $_firmware_update_flag_file = "/tmp/update";

  $_db_path_settings = "/opt/www/files/database/settings.DB3";
  $_db_path_logs = "/opt/www/files/database/logs.DB3";
  $_db_path_records = "/opt/www/files/record/.record.DB3";

  $_init_dir = $_SERVER['DOCUMENT_ROOT']."/files/init/";

  $_rview_setting_file = "/etc/rsupport/remoteview.conf";
}
$_firmware_check_url = "http://192.168.7.4/update/";

$log_backup_path = $_SERVER['DOCUMENT_ROOT'].'/files/database/backup/';
if(is_file($_db_path_settings)) require_once $_www_path.'/_common/db.php';
else initDB("output");

$_kvm_version = $_kvm_revision = "";
if(is_file($_firmware_version_file)){
  $version_info = parse_ini_file($_firmware_version_file);
  $_kvm_version = $version_info['VERSION'];
  $_kvm_revision = $version_info['REVISION'];
  unset($version_info);
}

$kvmDB = new kvmDB();

  if(isset($_SESSION["device_seq"])){
    $_local_device_seq = $_SESSION["device_seq"];
  }else{
    $_local_device_seq = $kvmDB->getDataSingle("SELECT seq FROM devices_data WHERE local = 'Y'");
    $_SESSION["device_seq"] = $_local_device_seq;
  }
  ###
  if(isset($_SESSION["device_name"])){
    $_local_device_name = $_SESSION["device_name"];
  }else{
    $_local_device_name = $kvmDB->getDataSingle("SELECT name FROM devices_data WHERE local = 'Y'");
    $_SESSION["device_name"] = $_local_device_name;
  }
  ###
  if(isset($_SESSION["device_ip"])){
    $_local_device_ip = $_SESSION["device_ip"];
  }else{
    //$_local_device_ip = $kvmDB->getDataSingle("SELECT ip4 FROM devices_data WHERE local = 'Y'");
    $_local_device_ip = $_SERVER["SERVER_ADDR"];
    $_SESSION["device_ip"] = $_local_device_ip;
  }
  ###
  $_local_device_mac = $kvmDB->getDataSingle("SELECT device_mac FROM preference");
  ###
  if(isset($_SESSION["device_display_type"])){
    $_device_display_type = $_SESSION["device_display_type"];
  }else{
    $_device_display_type = $kvmDB->getDataSingle("SELECT device_display FROM preference");
    $_SESSION["device_display_type"] = $_device_display_type;
  }
  ###
  if(isset($_SESSION["device_display_name"])){
    $_device_display_name = $_SESSION["device_display_name"];
  }else{
    $_device_display_name = ($_device_display_type == 'ip') ? $_local_device_ip : $_local_device_name;
    $_SESSION["device_display_name"] = $_device_display_name;
  }
  ###
  if(isset($_SESSION["pc_type"])){
    $_pc_type = $_SESSION["pc_type"];
  }else{
    $_pc_type = $kvmDB->getDataSingle("SELECT pc_type FROM preference");
    $_SESSION["pc_type"] = $_pc_type;
  }
  ###
  if(isset($_SESSION["keep_db_period"])){
    $_keep_db_period = $_SESSION["keep_db_period"];
  }else{
    $_keep_db_period = $kvmDB->getDataSingle("SELECT keep_db FROM preference");
    $_SESSION["keep_db_period"] = $_keep_db_period;
  }
  ###
  if(isset($_REQUEST['lang']) && $_REQUEST['lang'] != null){
    $_lang_code = $_REQUEST['lang'];
  }
  elseif(isset($_SESSION["language"]) && $_SESSION["language"] != ''){
    $_lang_code = $_SESSION["language"];
  }
  else{
    $_lang_code = $kvmDB->getDataSingle("SELECT language FROM preference");
    $_SESSION["language"] = $_lang_code;
  }

  if(isset($_kvm_string) == true) unset($_kvm_string);
  $langfile_name = (is_file($_www_path."/_langs/".$_lang_code.".ini") == true) ? $_lang_code : "en-US";
  $_kvm_string = parse_ini_file($_www_path."/_langs/".$langfile_name.".ini", true, INI_SCANNER_RAW);

  ###
  $_update_flag = $kvmDB->getDataSingle("SELECT update_flag FROM preference");
  if($_update_flag == '1'){
    update_db($_db_path_settings,$_init_dir."settings.DB3");
    $kvmDB->setData('UPDATE preference SET update_flag = "0"');
  }

unset($kvmDB,$langfile_name);


/* ******************
 * Functions
 * **************** */
//istreamer 체크
function istreamerCheck(){
  $result = true;
  if(strpos($_SERVER['SERVER_SOFTWARE'],"Win") == false){
    if(is_file("/var/run/istreamer.pid")){
      $pid = file("/var/run/istreamer.pid");
      if(posix_kill($pid[0],0) == false) $result = false;
      unset($pid);
    }
    else{
     $result = false;
    }
  }
  return $result;
}

//아이피 체크
function ipCheck(){
  $kvmDB = new kvmDB();
  $db_ip = $kvmDB->getDataSingle("SELECT ip4 FROM devices_data WHERE local = 'Y'");
  $real_ip = $_SERVER["SERVER_ADDR"];

  if($db_ip != $real_ip){
    $sql = "UPDATE devices_data SET ip4 = '".$real_ip."' WHERE local = 'Y'";
    $kvmDB->setData($sql);
    if(isset($_SESSION["device_ip"])) $_SESSION["device_ip"] = $real_ip;
  }
  unset($kvmDB);
}

//DB 셋업 체크
function setupCheck(){
  $arg = "";
  if(func_num_args() > 0){
    $arg_arr = func_get_args();
    $arg = $arg_arr[0];
    unset($arg_arr);
  }
  $kvmDB = new kvmDB();
  $is_device = $kvmDB->getDataSingle("SELECT seq FROM devices_data WHERE local = 'Y'");
  $is_user = $kvmDB->getDataSingle("SELECT id FROM users_data WHERE type = 'super'");
  $is_setup = $kvmDB->getDataSingle("SELECT is_setup FROM preference");
  unset($kvmDB);
  if($is_device == "" || $is_user == "" || $is_setup != "Y"){
    if($arg == "boolean"){
      $result = false;
    }else{
      $output  = "<!DOCTYPE html>\n<html>\n<head>";
      $output .= '<style type="text/css">p{font:bold 16px sans-serif; line-height:1.8; text-align:center; padding:7px;}</style>';
      $output .= '<script type="text/javascript">'.
                    'var second, time = 10, count = setInterval(function(){'.
                      'second = (time-- < 3) ? " second" : " seconds";'.
                      'document.getElementById("count").innerHTML = time + second;'.
                      'if(time == 0){ clearTimeout(count); location.href = "/setup"; }'.
                    '}, 1000);'.
                  '</script>';
      $output .= "<title>Device does not setup!!</title></head>\n<body>";
      $output .= '<p style="margin-top:100px;">This device does not setup. Redirection to Setup Page in <span id="count">10 seconds</span>...</p>';
      $output .= '<p>If does not refresh automatically, Click below link please.</p>';
      $output .= '<p><a href="/setup">Go to Setup Page</a></p>';
      $output .= "</body>\n</html>";
      exit($output);
    }
  }else{
    $result = true;
  }
  return $result;
}
//DB 초기화
function initDB($opt){
  $output  = "<!DOCTYPE html>\n<html><head>";
  $output .= '<style type="text/css">p{font:bold 16px sans-serif; line-height:1.8; text-align:center; padding:7px;}</style>';
  $output .= '<script type="text/javascript">'.
                'var second, time = 10, count = setInterval(function(){'.
                  'second = (time-- < 3) ? " second" : " seconds";'.
                  'document.getElementById("count").innerHTML = time + second;'.
                  'if(time == 0){ clearTimeout(count); location.href = "/setup"; }'.
                '}, 1000);'.
              '</script>';
  $output .= "<title>DATABASE ERROR!!</title></head>\n<body>\n";
  $output .= '<p style="padding:180px 0;color:red;text-align:center;font:bold 20px/40px sans-serif;">';

  //db복사
  if(copy($GLOBALS['_init_dir']."settings.DB3",$GLOBALS['_db_path_settings'])){
    exec("chown root.root ".$GLOBALS['_db_path_settings']);
    exec("chmod 664 ".$GLOBALS['_db_path_settings']);
    $output .= 'DATABASE ERROR!<br>';
    $output .= 'You must initialization and setup again this device.<br>';
    $output .= 'Redirection to setup Page in <span id="count">10 seconds</span>... or refresh this page.<br>';
    $result = true;
  }else{
    $output .= 'DATABASE ERROR!<br>';
    $output .= 'You must setup this device.<br>';
    $output .= 'Please reset this device and setup again.<br>';
    $result = false;
  }
  $output .= "</p></body>\n</html>";
  if ($opt=="output") exit($output);
  else return $result;
}

//펌웨어 업데이트 후 DB변경사항 적용
function get_db_map($db){
  try{
    $testDB = new kvmDB($db);
    $tables_result = $testDB -> getData("SELECT name,sql FROM 'sqlite_master' WHERE type = 'table'");
    $table = array();
    while($row = $tables_result->fetchArray()){
      $column = array();
      $column_set = explode(',',substr(strstr($row['sql'],'('),1,-1));
      foreach($column_set as $column_info){
        preg_match('/("|\')[\w]+("|\')/',$column_info,$column_name);
        $column[preg_replace('/("|\')/','',$column_name[0])] = str_replace($column_name[0],'',$column_info);
      }
      $table[$row['name']] = $column;
    }
    unset($testDB);
    return $table;
  }
  catch(Exception $e){
    return false;
  }
}

function update_db($current_db, $new_db){
  $testDB = new kvmDB($current_db);

  $current_map = get_db_map($current_db);
  $new_map = get_db_map($new_db);

  if(!$current_map || !$new_map) return false;

  $result = array('create_table'=>array(),'delete_table'=>array(),'alter_table'=>array());
  //change table
  $table_create = array_diff_assoc($new_map,$current_map);
  $table_delete = array_diff_assoc($current_map,$new_map);

  //create table
  foreach($table_create as $table_name => $column_info){
    $columns = array();
    foreach($column_info as $column_name => $column_type){
      array_push($columns,'"'.$column_name.'" '.$column_type);
    }
    $testDB->setData('CREATE TABLE IF NOT EXISTS "'.$table_name.'" ('.implode(', ',$columns).')');
    //echo "create table: ".$table_name."<br>";
    array_push($result['create_table'],$table_name);
    unset($columns);
  }

  //delete table
  foreach($table_delete as $table_name => $column_info){
    $testDB->setData('DROP TABLE "'.$table_name.'"');
    //echo "delete table: ".$table_name."<br>";
    array_push($result['delete_table'],$table_name);
  }

  $current_map = get_db_map($current_db);

  //compare column
  foreach($current_map as $table_name => $column_info){
    //currunt table
    $column_add = array_diff_key($new_map[$table_name],$column_info);
    foreach($column_add as $column_name => $column_type){
      $testDB->setData('ALTER TABLE "'.$table_name.'" ADD COLUMN "'.$column_name.'" '.preg_replace('/(UNIQUE|PRIMARY|KEY|NOT|NULL)/','',$column_type));
      //echo "alter table: ".$table_name."->'".$column_name."' as ".$column_type."<br>";
      array_push($result['alter_table'],$table_name."->'".$column_name."' as ".$column_type);
    }
  }
  $testDB->setData('VACUUM');
  unset($testDB);

  //if(count($result['create_table']) == 0 && count($result['delete_table']) == 0 && count($result['alter_table']) == 0) $result = false;
  return $result;
}


//DB 유효성 확인
function certifyDB($db_path){
  $db_map = get_db_map($db_path);
  if(!$db_map) return false;
  else {
    return update_db($db_path, $GLOBALS['_init_dir'].'settings.DB3');
    //return true;
  }
/*
  $return_result = true;
  $db_map = get_db_map($GLOBALS['_init_dir']."settings.DB3");
  $debug = "";
  $kvmDB = new kvmDB($db_path);
  foreach($db_structure_map as $table => $tableops){
    foreach($tableops as $row => $type){
      $sql_result = $kvmDB->getDataSingle("SELECT type FROM sqlite_master WHERE name = '".$table."' AND sql LIKE '%\"".$row."\" ".$type."%'");
      if($sql_result != "table"){
        $debug .= $table."/".$row."\n";
        $return_result = false;
      }
    }
  }
  unset($kvmDB);
  //echo nl2br($debug);
  return update_db($db_path, $GLOBALS['_init_dir'].'settings.DB3');
  */
}

//한달이상 지난 쓸모없는 DB는 삭제
function deleteOldDB(){
  if(func_num_args() > 0){
    $arg = func_get_args();
    $period = $arg[0];
    unset($arg);
  }else{
    $period = $GLOBALS['_keep_db_period'];
  }

  $unit = strtolower(substr($period, -1));
  if(is_numeric($unit) == true){
    $unit = "d";
  }else{
    $period = substr($period,0,-1);
    if(!preg_match('/y|m|d/',$unit)) $unit = "d";
  }
  if(is_numeric($period) == false){
    $period = preg_replace("/[^\d]/","",$period);
    if($period == "" || $period == null){
      $period = 1;
      $unit = "m";
    }
  }

  $target_year = date("Y");
  $target_month = date("m");
  $target_day = date("d");
  if($unit == 'y') $target_year -= $period;
  if($unit == 'm') $target_month -= $period;
  if($unit == 'd') $target_day -= $period;
  $target_date = date("Y-m-d", mktime(0,0,0,$target_month,$target_day,$target_year));

  $kvmDB = new kvmDB();
  $logDB = new kvmDB($GLOBALS['_db_path_logs']);
  //삭제된 유저
  $kvmDB->setData("DELETE FROM users_data WHERE (DATE(date) < '".$target_date."') AND active = 'N'");
  //삭제된 장비
  $kvmDB->setData("DELETE FROM devices_data WHERE (DATE(date) < '".$target_date."') AND active = 'N'");
  //로그
  $logDB->setData("DELETE FROM logs_data WHERE (DATE(time) < '".$target_date."')");
  //DB크기 줄임
  $kvmDB->setData("VACUUM");
  $logDB->setData("VACUUM");
  unset($kvmDB,$logDB);
}

//언어별 메시지 출력
function msg($code){
  return isset($GLOBALS['_kvm_string']['string'][$code]) ? $GLOBALS['_kvm_string']['string'][$code] : "";
}

//로그 남기기
function inputLog($type, $location, $target, $kind, $user, $code, $detail){
  $logDB = new kvmDB($GLOBALS['_db_path_logs']);
  $kvmDB = new kvmDB();
  $is_setup = $kvmDB->getDataSingle("SELECT is_setup FROM preference");
  if($is_setup == 'Y'){
    $sql = "INSERT INTO logs_data (type,time,location,target,kind,user,code,detail)
            VALUES ( '".strtoupper($type)."', DATETIME('NOW','localtime'), '".$location."', '".$target."',
                     '".strtoupper($kind)."', '".$user."', '".strtoupper($code)."', '".$detail."' )";
    $logDB->setData($sql);
  }
  unset($logDB,$kvmDB);
}

//로그 변환하기
function outputLog($data){
  $kvmDB = new kvmDB();
  $is_past = (isset($data["past"]) == true) ? $data["past"] : false;
  $get_device_name_sql = "SELECT name FROM devices_data WHERE seq = '";
  $get_user_id_sql = "SELECT id FROM users_data WHERE seq = '";

  //past
  $data["past"] = ($is_past == true) ? " past" : "";

  //type
  if(isset($data["type"])) {
    $data["type"] = strtolower($data["type"]);
  }

  //time
  if(isset($data["time"])){
    $log_datetime = explode(" ",$data['time']);
    $log_date = explode("-",$log_datetime[0]);
    $log_time = explode(":",$log_datetime[1]);
    $log_timestamp = mktime($log_time[0],$log_time[1],$log_time[2],$log_date[1],$log_date[2],$log_date[0]);
    unset($log_date,$log_time);

    $date_format = msg("DATE_FORMAT");
    $data["time"] = date("m.d G:i",$log_timestamp);
    $data["date"] = date("Y-m-d",$log_timestamp);

    //for detail info
    $data["full_time"] = str_replace(
                          array("am","pm","Sun","Mon","Tue","Wed","Thu","Fri","Sat"),
                          array(msg("DATE_AM"),msg("DATE_PM"),
                                msg("DATE_SUN"),msg("DATE_MON"),msg("DATE_TUE"),msg("DATE_WED"),
                                msg("DATE_THU"),msg("DATE_FRI"),msg("DATE_SAT")),
                          date($date_format,$log_timestamp));
  }

  //location
  if(isset($data["location"])){
    $location_array = explode("#",$data['location']);
    $data["location"] = msg($location_array[0]);
    if(isset($location_array[1])){
      $data["device"] = ($is_past == false) ? $kvmDB->getDataSingle($get_device_name_sql.$location_array[1]."'") : $location_array[1];
    }else{
      $data["device"] = "";
    }
    unset($location_array);
  }

  //target
  if(isset($data["target"])){
    $target_array = explode("#",$data['target']);
    $data["target_type"] = $target_array[0];
    switch($data["target_type"]){
      case "LOCATION": $data["target"] = msg($target_array[1]); break;
      case "USER": $data["target"] = $kvmDB->getDataSingle($get_user_id_sql.$target_array[1]."'"); break;
      case "DEVICE": $data["target"] = $kvmDB->getDataSingle($get_device_name_sql.$target_array[1]."'"); break;
      default: $data["target_type"] = ""; break;
    }
    unset($target_array);
  }

  //kind
  if(isset($data["kind"])){
    $data["kind"] = msg($data['kind']);
  }

  //user
  if(isset($data["user"])){
    $user_array = explode("#",$data['user']);

    if(isset($user_array[1]) == true || $is_past == true){
      $data["user"] = $user_array[0];
    } else{
      $data["user"] = $kvmDB->getDataSingle($get_user_id_sql.$user_array[0]."'");
    }
    if($data["user"] == "unknown" || $data["user"] == "" || $data["user"] == "#"){
      $data["user"] = msg("UNKNOWN_USER");
    }elseif($data["user"] == strtolower("system")){
      $data["user"] = msg("SYSTEM");
    }
    unset($user_array);
  }

  //code
  if(isset($data["code"])){
    $log_message = msg($data['code']);
    $message_search  = array("[#who#]","[#when#]","[#where#]","알 수 없음님이");
    $message_replace = array($data["user"],$data["full_time"],$data["location"],"누군가가");
    $log_message = str_replace($message_search, $message_replace, $log_message);
    $data["code"] = nl2br(ucfirst($log_message));
    unset($message_search,$message_replace);
  }

  //detail
  if(isset($data["detail"])){
    if(strpos($data["code"],'[#values#]') !== false){
      $detail_arr = explode('[#change_devices#]',$data['detail']);
      $detail_search  = array("[#values#]","[#devices#]","[#success_1#]","[#success_0#]");
      $detail_replace = array(nl2br($detail_arr[0]),nl2br($detail_arr[1]),msg("SUCCESS"),msg("FAILED"));
      $data["code"] = str_replace($detail_search, $detail_replace, $data["code"]);
      $data["detail"] = "";
      unset($detail_arr,$detail_search,$detail_replace);
    }else{
      $data["detail"] = '<br />'.nl2br($data['detail']);
    }
  }

  unset($kvmDB);
  return $data;
}

//로그백업
function backupLog(){
  $logDB = new kvmDB($GLOBALS['_db_path_logs']);
  //이번달과 로그 첫번째달
  $this_month = (date("Y")*12)+date("m");
  $log_first_month = $logDB->getDataSingle("SELECT time FROM logs_data ORDER BY time ASC LIMIT 1");
  $log_first_month = explode("-",$log_first_month);
  $log_first_month = $log_first_month[0]*12+$log_first_month[1];
  $encoding = "EUC-KR";

  //이번달과
  if($this_month > $log_first_month){
    for($i=$log_first_month; $i<$this_month; $i++){
      $current_month = $i%12 == "0" ? "12" : $i%12;
      $current_year = ($i-$current_month)/12;
      if($current_month < 10) $current_month = "0".$current_month;
      $backup_file = $GLOBALS['log_backup_path']."kvmLog-".$current_year."-".$current_month.".csv";

      //파일 있는가 검사하여 DB읽어 백업파일 생성
      if(is_file($backup_file) == false){
        $rs = $logDB->getData("SELECT * FROM logs_data WHERE time LIKE '".$current_year."-".$current_month."%' ORDER BY time ASC");
        $csv = array(array(
          'seq' => msg('LOGS_103'), 'type' => msg('TYPE'),
          'location' => msg('LOGS_104'), 'target' => msg('LOGS_106'),
          'kind' => msg('LOGS_105'), 'user' => msg('LOGS_107'),
          'code' => msg('LOGS_108'), 'detail' => msg('LOGS_109')
        ));
        while($data = $rs->fetchArray(SQLITE3_ASSOC)){
          $data = outputLog($data);
          if($data["device"] != "" && $data["location"] != "") $data["device"] = "(@".$data["device"].")";
          $data["location"] .= $data["device"];
          $data['seq'] = $data['full_time'];
          $data['type'] = msg(strtoupper($data['type']));
          $data['detail'] = str_replace('<br />','',$data['detail']);
          unset($data['full_time'],$data['time'],$data['count'],$data['date'],$data['target_type'],$data['past'],$data['device']);
          array_push($csv,$data);
        }
        if(count($csv) > 1){
          $fp = fopen($backup_file, 'w');
          foreach($csv as $line){
            foreach($line as $key => $cell) $line[$key] = mb_convert_encoding($cell,$encoding,"UTF-8");
            fputcsv($fp, $line,',','"');
          }
          fclose($fp);
        }
      }
    }
    unset($data,$csv,$line);
  }
  unset($logDB);
}

//디스크 유무 검사 및 남은 용량
function getDiskInfo(){
  $used = "0";
  $available = "0";
  $total = "0";
  $percent = "0";

  if(strpos($_SERVER['SERVER_SOFTWARE'],"Win")) $is_hdd = 'Y';
  else{
    exec("df /dev/hda1",$df);
    $is_hdd = 'N';
    if($df[1] != ""){
      $is_hdd = 'Y';
      preg_match_all("/\b\d+/",$df[1],$diskinfo);
      $used = $diskinfo[0][1];
      $available = $diskinfo[0][2];
      $total = $used + $available;
      $percent = round($used/$total,3)*100;
      unset($diskinfo,$df);
    }
  }

  return Array("is_hdd"=>$is_hdd, "total"=>$total, "available"=>$available, "used"=>$used, "percent"=>$percent);
}

//정수를 문자열로 인코딩함
function base52($val){
  $chars='cDvNrVWaKtuTjJpUeyICoFwBqxlPfghZHiRSbEsOGMndQXzAkYmL';
  $str = '';
  for($i=0;$i<ceil(strlen($val)/9);$i++){
    $this_val = substr($val,$i*9,9);
    do{
        $j = $this_val % 52;
        $str = $chars[$j] .$str;
        $this_val = ($this_val - $j) / 52;
    }while($this_val > 0);
  }
  return $str;
}

//pw암,복호화
function cryptPW($pw){
  $salt = "e61d80b5";
  $hash = md5($salt.md5($pw.$salt));
  return $hash;
}

//리부트
function execReboot($sec){
  $sec = $sec ? $sec : 0;
  sleep($sec);
  exec("/bin/reboot.sh", $output);
}

//세션 모두 삭제
function forceSession(){
  $_session_path = ini_get("session.save_path");
  if(strpos($_SERVER['SERVER_SOFTWARE'],"Win")) exec("del /q ".$_session_path."\*");
  else exec("rm -f ".$_session_path."/*");

  if(isset($_SESSION["user_id"]) && $_SESSION["user_id"] != null) session_destroy();
//array_map("unlink", glob($_session_path.'\*'));
}

//펌웨어 버전확인
function getFirmwareVersion($get){
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/ini.php';
  //require_once $_SERVER['DOCUMENT_ROOT'].'/_common/curl.php';

  $firmware_info = array();
  $ini = new INIManager($GLOBALS['_firmware_version_file']);
  if(!$ini->Initialize(false)){
    $current_firmware_version = "";
  }else{
    $arrGet = $ini->getINIData();
    $current_firmware_version = $arrGet["VERSION"];
  }
  unset($ini);
  $firmware_info['current_version'] = $current_firmware_version;
/*
  if($get != "current"){
    $curl = new CURL();
    $curl_opts = array(
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_CONNECTTIMEOUT => 5
    );
    $curl->addSession($GLOBALS['_firmware_check_url']."version", $curl_opts);
    $curl_result = $curl->exec();
    $curl->clear();
    unset($crul,$curl_opts);

    if($curl_result != "" && strpos($curl_result,"<html>") === false){
      $newest_vals = parse_ini_string($curl_result);
    }
    $firmware_info['newest_version'] = isset($newest_vals['VERSION'])? $newest_vals['VERSION'] : "";
    $firmware_info['revision'] = isset($newest_vals['REVISION'])? $newest_vals['REVISION'] : "";
    $firmware_info['url'] = isset($newest_vals['URL'])? $newest_vals['URL'] : $GLOBALS['_firmware_check_url']."firmware-".$firmware_info['newest_version'].".zip";
    $firmware_info['hash'] = isset($newest_vals['SHA1'])? $newest_vals['SHA1'] : "";
    $firmware_info['size'] = isset($newest_vals['SIZE'])? $newest_vals['SIZE'] : "";
  }
*/
  return $firmware_info;
}

//접속자 정보
function getBrowser(){
  $u_agent = $_SERVER['HTTP_USER_AGENT'];
  $bname = 'Unknown';
  $platform = 'Unknown';
  $version = "";
  $os_version = "";

  //First get the platform
  if(preg_match('/iphone/i', $u_agent)) $platform = 'iOS';
  elseif(preg_match('/android/i', $u_agent)) $platform = 'Android';
  elseif(preg_match('/linux/i', $u_agent)) $platform = 'Linux';
  elseif(preg_match('/macintosh|mac os x/i', $u_agent)) $platform = 'Mac';
  elseif(preg_match('/windows|win32/i', $u_agent)){
    $platform = 'Windows';
    if(preg_match('/NT 6.1/i', $u_agent))$os_version = "7";
    elseif(preg_match('/NT 6|NT 6.0/i', $u_agent)) $os_version = "Vista";
    elseif(preg_match('/NT 5.1/i', $u_agent)) $os_version = "XP";
    elseif(preg_match('/NT 5|NT 5.0/i', $u_agent)) $os_version = "2000";
  }

  // Next get the name of the useragent yes seperately and for good reason
  if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)){
    $bname = 'Internet Explorer';
    $ub = "MSIE";
  }
  elseif(preg_match('/Firefox/i',$u_agent)){
    $bname = 'Mozilla Firefox';
    $ub = "Firefox";
  }
  elseif(preg_match('/Chrome/i',$u_agent)){
    $bname = 'Google Chrome';
    $ub = "Chrome";
  }
  elseif(preg_match('/Safari/i',$u_agent)){
    if(preg_match('/android/i', $u_agent)){
      $bname = 'Webkit';
      $ub = "Webkit";
    }
    else{
      $bname = 'Apple Safari';
      $ub = "Safari";
    }
  }
  elseif(preg_match('/Opera/i',$u_agent)){
    $bname = 'Opera';
    $ub = "Opera";
  }
  elseif(preg_match('/Netscape/i',$u_agent)){
    $bname = 'Netscape';
    $ub = "Netscape";
  }

  // finally get the correct version number
  $known = array('Version', $ub, 'other');
  $pattern = '#(?<browser>'.join('|', $known).')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
  if(!preg_match_all($pattern, $u_agent, $matches)){
      // we have no matching number just continue
  }

  // see how many we have
  $i = count($matches['browser']);
  if($i != 1) {
      if(strripos($u_agent,"Version") < strripos($u_agent,$ub)) $version= $matches['version'][0];
      else $version= $matches['version'][1];
  }
  else $version= $matches['version'][0];

  // check if we have a number
  if($version==null || $version=="") {$version="?";}
  return array(
      'userAgent' => $u_agent,
      'browser' => $bname,
      'version' => $version,
      'platform' => $platform,
      'os_version' => $os_version,
      'pattern' => $pattern
  );
}

/* ** etc functions ** */
/*
function startWith($haystack,$needle,$case=true) {
  if($case) return (strcmp(substr($haystack, 0, strlen($needle)),$needle)===0);
  return (strcasecmp(substr($haystack, 0, strlen($needle)),$needle)===0);
}

function endWith($haystack,$needle,$case=true) {
  if($case) return (strcmp(substr($haystack, strlen($haystack) - strlen($needle)),$needle)===0);
  return (strcasecmp(substr($haystack, strlen($haystack) - strlen($needle)),$needle)===0);
}

function substrKr($str, $start_pos, $len, $suffix){
  if($len >= strlen($str)) return $str;
  $klen = $len - 1;
  while(ord($str[$klen]) & 0x80) $klen--;
  return substr($str, $start_pos, $len - (($len + $klen + 1) % 2)).$suffix;
}

function guid(){
  $uuid = "";
  if(function_exists('com_create_guid')) $uuid = com_create_guid();
  else{
    mt_srand((double) microtime() * 10000);
    $chid = strtoupper(md5(uniqid(rand(), true)));
    $typehen = chr(45);
    $uuid = chr(123).substr($chid, 0, 8).$typehen.substr($chid, 8, 4).$typehen
            .substr($chid, 12, 4).$typehen.substr($chid, 16, 4).$typehen.substr($chid, 20, 12).chr(125);
  }
  return $uuid;
}
*/
//for test
function print_array($arr){
  echo '<pre>';
  print_r($arr);
  echo '</pre>';
}
?>
