<?php
/* ****************** *
 * INI control class
 ******************** */
class INIManager{

  var $_FILE_PATH;
  var $_error_msg;
  var $_ini_data;

  function INIManager($file_path){
    $this->_FILE_PATH = $file_path;
  }

  function Initialize($isGroup){
    $res = false;

    if(file_exists($this->_FILE_PATH) == true){
      $this->_ini_data = parse_ini_file($this->_FILE_PATH, $isGroup);
      $res = true;
    }
    else{
      $res = false;
    }

    return $res;
  }

  function getINIData(){
    return $this->_ini_data;
  }

  function setINIData($arr){
    $this->_ini_data = $arr;
  }

  function writeINI(){
    $res = false;
    if($fp = fopen($this->_FILE_PATH, 'w')){
      if(flock($fp, LOCK_EX)){
        while(list($key, $val)= each($this->_ini_data)){
          $line = $key."=".$val.PHP_EOL;
          fwrite($fp, $line);
        }
        flock($fp, LOCK_UN);
      }

      fclose($fp);
    }
  }

  function writeINI_Section(){
    $res = false;
    try {
      if($fp = fopen($this->_FILE_PATH, 'w')){
        if(flock($fp, LOCK_EX)){
          while(list($key, $val) = each($this->_ini_data)){
            if( is_array($val) ){
              $line = "[".$key."]".PHP_EOL;
              fwrite($fp, $line);
              while(list($key2, $val2) = each($this->_ini_data[$key])){
                $line = $key2."=".$val2.PHP_EOL;
                fwrite($fp, $line);
              }
            }
          }
          flock($fp, LOCK_UN);
        }
        $res = true;
      }
      else {
        $res = false;
      }
    }
    catch (Exception $e){
      $res = false;
    }
    return $res;
  }

  function __destruct(){
    unset($this->_FILE_PATH);
    unset($this->_error_msg);
    unset($this->_ini_data);
  }

}

?>