<?php
error_reporting(E_ERROR);
/* ********************** *
 * Socket control class
 ************************ */
class kvmServer{
  var $_sock;
  var $_timeout = 100;
  var $host = "localhost";
  var $port = "9734";
  var $_error_msg = "";

  function kvmServer(){
    $this->_sock = socket_create(AF_INET, SOCK_STREAM, 0);
    //socket_set_option($this->_sock, SOL_SOCKET, SO_SNDTIMEO, array("sec" => 0, "usec" => $this->_timeout));
  }

  function connect($host, $port){
    $res = FALSE;
    try {
      if(strlen($host) > 1) $this->host = $host;
      if($port > 1) $this->port = $port;
      #echo $this->host."<BR/>".$this->port."<BR/>";
      $res = socket_connect($this->_sock, $this->host, $this->port);
    }
    catch(Exception $e) { $this->_error_msg = $e.getMessage(); }

    if(!$res && strlen($this->_error_msg)) $this->_error_msg = "error : unable to connect a socket.";
    return $res;
  }

  function send($msg){
    $res = FALSE;
    try{ $res = socket_write($this->_sock, $msg, strlen($msg)); }
    catch(Exception $e){ $this->_error_msg = $e.getMessage(); }

    if(!$res) $this->_error_msg = "error : unable to send a message.";
    return $res;
  }

  function close(){
    if($this->_sock) socket_close($this->_sock);
    unset($this->sock);
  }
}


/* ********************** *
 * Creat Socket Message
 ************************ */
class HeaderType{
  const SNAPSHOT = 17;
  const IPTABLE = 21;
}

class Operation{
  const NOTICE = 0;
  const REQUEST = 1;
  const RESPONSE = 2;
  const WRONG = 4;
  const RELAY = 8;
  const BROADCASTING = 16;
}

class kvmMessage{
  var $isDebug = true;

  //Header protocol define
  var $_type = HeaderType::SNAPSHOT;
  var $_length = 12;
  var $_opcode = Operation::NOTICE;
  var $_version = 1;
  var $_identify = 1;
  var $_tlvs = 0;

  //body protocol define
  var $_action_type = 1;
  var $_magic = 255;
  var $_header;
  var $_body;

  function kvmMessage($type, $command){
    $this->_type = $type;
    if(strlen($command) > 1){
      $this->_action_type = $command;
      $this->_length = 11 + strlen($command);
    }
  }

  function makeHeader(){
    $this->_header = pack("S", $this->_type);
    $this->_header .= pack("S", $this->_length);
    $this->_header .= pack("C", $this->_opcode);
    $this->_header .= pack("C", $this->_version);
    $this->_header .= pack("S", $this->_identify);
    $this->_header .= pack("C", $this->_tlvs);
    $this->_header .= pack("C", $this->_magic);
    #echo "HEADER(C) : ".$this->_header."<BR/>";
    #if($this->isDebug) echo "HEADER : ".$this->_type.$this->_length.$this->_opcode.$this->_version.$this->_identify.$this->_tlvs.$this->_magic."<BR/>";
  }

  function makeBody(){
    switch($this->_type){
      case HeaderType::SNAPSHOT :
        $this->_body = pack("C", $this->_action_type);
        $this->_body .= pack("C", $this->_magic);
      break;
      case HeaderType::IPTABLE :
        $this->_body = $this->_action_type;
        $this->_body .= pack("C", $this->_magic);
      break;
    }
    #echo "BODY(C) : ".$this->_body."<BR/>";
    #if($this->isDebug) echo "BODY : ".$this->_action_type.$this->_magic."<BR/>";
  }

  function checkVariable(){
    return true;
  }

  function getMessage(){
    return $this->_header.$this->_body;
  }

  function getMessageDirect(){
    $this->makeHeader();
    $this->makebody();

    #if($this->isDebug) echo "TOTAL : ".$this->_header.$this->_body."<BR/>";
    return $this->_header.$this->_body;
  }
}


/* ****************************** *
 * socket send function example
 ******************************** */
function socketSend($command){
  $kvmServer = new kvmServer();
  $kvmMessage = new kvmMessage(HeaderType::IPTABLE, $command);

  if($kvmServer->connect($address, $port)){
    #echo "접속 성공<br>";

    $sendMessage = $kvmMessage->getMessageDirect();
    #echo "message -> ".$sendMessage."<br>";

    if($kvmServer->send($kvmMessage->getMessageDirect())){
      #echo "보내기 성공<br>";
    }else{
      #echo "보내기 실패<br>";
    }
  }else {
    #echo "접속실패<br>";
  }
  unset($kvmServer);
  unset($kvmMessage);
}
?>
