<?
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/curl.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/json.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/ini.php';

$default_domain = 'https://biz.rview.com';
$rview_data = array();
$_this_location = 'L_SETTINGS';
$_this_target = 'LOCATION#L_SETTINGS_RVIEW';
$_this_user = $_SESSION['user_seq'];
getRviewINI();
$rview_url_info = array(
  'companyCheck' => array(
    'url' => '/RemoteView/command/agent/Agent_companyCheck.aspx',
    'post_field' => 'DOMAIN'
  ),
  'install' => array(
    'url' => '/RemoteView/Command/agent/agent_install.aspx',
    'post_field' => 'GUID, DISPLAYNAME, SHAREDFOLDER, WEBID, WEBPASS, BIZID, ACCESSID, ACCESSPWD, SSL, AGENTIP, AGENTMAC, PCNAME, OSNAME, GROUPID, RSVFlag'
  ),
  'validate' => array(
    'url' => '/RemoteView/command/agent/Agent_Validate.aspx',
    'post_field' => 'AccessID, AccessPasswd'
  ),
  'delete' => array(
    'url' => '/RemoteView/command/agent/Agent_Delete.aspx',
    'post_field' => 'GUID, WEBID, WEBPASS, BizID'
  ),
  'userCheck' => array(
    'url' => '/RemoteView/Command/agent/agent_userCheck.aspx',
    'post_field' => 'BIZID, WEBID, WEBPASS'
  ),
  'login' => array(
    'url' => '/RemoteView/command/agent/agent_login.aspx',
    'post_field' => 'GUID, RVAV, RSVFlag'
  ),
  'logout' => array(
    'url' => '/RemoteView/command/agent/Agent_logout.aspx',
    'post_field' => 'GUID'
  ),
  'session_result' => array(
    'url' => '/RemoteView/command/agent/Agent_session_result.aspx',
    'post_field' => 'GUID, CONNRESULT, AGENTIP, MACADDR, OSNAME, PCNAME, SESSIONIP, SESSIONPORT, RMCPORT, RMFPORT, CPU,  MEM, HDD'
  ),
  'config_modify' => array(
    'url' => '/RemoteView/command/agent/Agent_config_modify.aspx',
    'post_field' => 'GUID, DISPLAYNAME, SHAREDFOLDER, SSL, AGENTIP, MACADDR, OSNAME, PCNAME, RMCPORT, RMFPORT, AUTOSCREENLOCK, AUTOSYSTEMLOCK'
  ),
  'account_change' => array(
    'url' => '/RemoteView/command/agent/Agent_account_change.aspx',
    'post_field' => 'GUID, OldAccessID, OldAccessPwd, NewAccessID, NewAccessPwd'
  )
);

if(isset($rview_agent_data['WebServer']) == false || $rview_agent_data['WebServer'] == null || $rview_agent_data['WebServer'] == ''){
  $rview_domain = (isset($_POST['SERVERADDR'])) ? $_POST['SERVERADDR'] : $default_domain;
  $set_rview_ini_data = array(
    'WebServer' => $rview_domain
  );
  setRviewINI($set_rview_ini_data);
}else{
  $rview_domain = $rview_agent_data['WebServer'];
}

/* ***********************
 * functions
 ************************* */
function getRviewINI(){
  $GLOBALS['rview_ini_data'] = parse_ini_file($GLOBALS['_rview_setting_file'],true,INI_SCANNER_RAW);
  $GLOBALS['rview_agent_data'] = $GLOBALS['rview_ini_data']['Agent'];
}

function setRviewINI($array = array()){
  if(!isset($GLOBALS['rview_ini_data'])) getRviewINI();
  $GLOBALS['rview_ini'] = new INIManager($GLOBALS['_rview_setting_file']);
  $GLOBALS['rview_ini_data']['Agent'] = array_merge($GLOBALS['rview_agent_data'],$array);
  $GLOBALS['rview_ini']->setINIData($GLOBALS['rview_ini_data']);
  $GLOBALS['rview_ini']->writeINI_Section();
  unset($GLOBALS['rview_ini']);
}

function jsonEchoEnd(){
  if(isset($GLOBALS['rview_json'])){
    $GLOBALS['rview_json']->setJsonArray($GLOBALS['rview_data']);
    echo $GLOBALS['rview_json']->getJsonEncode();
    unset($GLOBALS['rview_json']);
    if(isset($GLOBALS['ini'])) unset($GLOBALS['ini']);
    exit();
  }
}

function getRviewMessage($code = 0){
  return msg('RVIEW_MSG_'.$code);
}

function getResponse($action = ''){
  if($action == '') return false;

  $request_url = $GLOBALS['rview_url_info'][$action]['url'];
  $post_fields = $GLOBALS['rview_url_info'][$action]['post_field'];

  $post_data = array();
  foreach(explode(',',str_replace(array(' ','\n'),'',$post_fields)) as $name){
    $upper_name = strtoupper($name);
    if((isset($GLOBALS['_POST'][$upper_name]) == false || $GLOBALS['_POST'][$upper_name] == '') && isset($GLOBALS['rview_data'][$upper_name]) == false){
      $GLOBALS['rview_data']['type'] = 'error';
      //$GLOBALS['rview_data']['message'] = msg('RVIEW_401').' ('.$name.')';
      $GLOBALS['rview_data']['message'] = msg('RVIEW_401');
      if(isset($GLOBALS['rview_json'])) jsonEchoEnd();
    }else{
      $value = isset($GLOBALS['_POST'][$upper_name]) ? $GLOBALS['_POST'][$upper_name] : $GLOBALS['rview_data'][$upper_name];
      array_push($post_data, $name."=".$value);
      $GLOBALS['rview_data'][$upper_name] = $value;
    }
  }

  $post_data = implode('&',$post_data);
  $GLOBALS['rview_data']['url'] = $GLOBALS['rview_domain'].$request_url;
  $GLOBALS['rview_data']['post_datas'] = $post_data;

    $curl = new CURL();
    $curl_opts = array(
      CURLOPT_RETURNTRANSFER => true
     ,CURLOPT_FOLLOWLOCATION => true
     ,CURLOPT_SSL_VERIFYPEER => false
     ,CURLOPT_SSLVERSION => 3
     ,CURLOPT_POST => true
     ,CURLOPT_POSTFIELDS => $post_data
    );
    $curl->addSession($GLOBALS['rview_domain'].$request_url, $curl_opts);
    $xml_data = $curl->exec();
    $curl->clear();
    unset($crul,$curl_opts);

  if($xml_data == null){
    $GLOBALS['rview_data']['type'] = 'error';
    $GLOBALS['rview_data']['message'] = msg('RVIEW_403');
    return false;
  }
/* XML PARSER
  $xml_parser = xml_parser_create();
  xml_parse_into_struct($xml_parser,$xml_data,$parsing_data);
  xml_parser_free($xml_parser);

  foreach($parsing_data as $val){
    if($val['type'] == 'complete') $GLOBALS['rview_data'][$val['tag']] = isset($val['value']) ? $val['value'] : '';
  }
  unset($parsing_data);
// */

  $xml_data = str_replace(array('> <','> ',' <'),array('><','>','<'),preg_replace('/\t|\n|\r|<META[\w\s-_=\'\"\/;]+>|(<DATA>)|(<\/[A-Z0-9_]+>)/','',$xml_data));
  $xml_data = str_replace(array('<','>'),array("\n",'='),preg_replace('/(^<)|(\s$)/','',$xml_data));
  $xml_data = parse_ini_string($xml_data);
  $GLOBALS['rview_data'] = array_merge($GLOBALS['rview_data'],$xml_data);
  unset($xml_data);

  if(isset($GLOBALS['rview_json']) && $GLOBALS['rview_data']['RESULT'] > 100){
    $GLOBALS['rview_data']['type'] = 'error';
    $GLOBALS['rview_data']['post_datas'] = $GLOBALS['rview_data']['post_datas'];
    //$GLOBALS['rview_data']['message'] = getRviewMessage($GLOBALS['rview_data']['RESULT']).'/n/'.$GLOBALS['rview_data']['ERRORMSG'];
    $GLOBALS['rview_data']['message'] = getRviewMessage($GLOBALS['rview_data']['RESULT']);
    jsonEchoEnd();
  }

  return true;
}

?>