<?php
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

if(isset($_SESSION["user_type"]) == false || isset($_SESSION["user_seq"]) == false || isset($current_device) == false || isset($action_file) == false){
  header('Location: /signin');
}
isset($screen_view) == false && $screen_view = false;
isset($local_action) == false && $local_action = false;
$innerText = "";
$device_list = array();
$cookie_name = 'device_order';
if(isset($_COOKIE[$cookie_name])){
  $orderby = $_COOKIE[$cookie_name];
}else{
  setCookie($cookie_name,'date',0,'/');
  $orderby = 'date';
}

if($orderby == 'date'){
  $name_active = 'active';
  $sort_key = 'rowid';
}else if($orderby == 'name'){
  $date_active = 'active';
  $sort_key = 'name';
}

$local_device_sql ="SELECT rowid, seq, name, ip4, web_port FROM devices_data WHERE local = 'Y'";
if($_SESSION["user_type"] == "admin" || $_SESSION["user_type"] == "super"){
  $external_device_sql = "SELECT rowid, seq, name, ip4, web_port, local, pending FROM devices_data WHERE local = 'N' AND active = 'Y'";
}else{
  $external_device_sql = "SELECT di.rowid, di.seq, di.name, di.ip4, di.ip6, di.web_port, di.pending
                          FROM devices_data di, user_device_map dm
                          WHERE (di.seq = dm.device AND dm.user = '".$_SESSION["user_seq"]."') AND active = 'Y'
                          ORDER BY dm.seq";
}

$kvmDB = new kvmDB();
$local_device = $kvmDB->getData($local_device_sql);
if($row = $local_device->fetchArray()){
  $device_list[0]['rowid'] = $row['rowid'];
  $device_list[0]['seq'] = $row['seq'];
  $device_list[0]['name'] = $row['name'];
  $device_list[0]['ip'] = $row['ip4'];
  $device_list[0]['port'] = $row['web_port'];
  $device_list[0]['local'] = 'Y';
  $device_list[0]['pending'] = '';
}
$external_device = $kvmDB->getData($external_device_sql);
$i = 1;
while($row = $external_device->fetchArray()){
  $device_list[$i]['rowid'] = $row['rowid'];
  $device_list[$i]['seq'] = $row['seq'];
  $device_list[$i]['name'] = $row['name'];
  $device_list[$i]['ip'] = $row['ip4'];
  $device_list[$i]['port'] = $row['web_port'];
  $device_list[$i]['local'] = 'N';
  $device_list[$i]['pending'] = $row['pending'];
  $i++;
}
unset($i,$row,$local_device,$external_device);

foreach($device_list as $tmpRecords){
  $sortColumn[] = $tmpRecords[$sort_key];
}
array_multisort($sortColumn, SORT_ASC, $device_list);

foreach($device_list as $device){
  if($device['seq'] == ''){
    $kvmDB->setData("DELETE FROM devices_data WHERE seq = ''");
  }else{
    $device_local_class = $device_current_class = $device_pending_class = $device_pending_icon = "";

    if($_device_display_type == "ip"){
      $device_display_name = $device['ip'];
      $device_display_name_tooltip = $device['name'];
    }else{
      $device_display_name = $device['name'];
      $device_display_name_tooltip = $device['ip'];
    }

    if($device['local'] == "Y"){
      $device_local_class = "local";
      if(isset($current_device) == false || $current_device == '' || $current_device == null) $current_device = $device['seq'];
      $device_pending_icon = '<span class="state"></span>';
      $device_addr = '';
      $device_port = '';
    }else{
      $device_addr = $device['ip'];
      $device_port = $device['port'];
    }

    if($device['seq'] == $current_device) $device_current_class = "current";

    if($device['pending'] == 'Y'){
      $device_pending_class = "pending";
    }elseif ($device['pending'] == 'N'){
      $device_pending_class = "new";
      $device_pending_icon = '<span class="state">new</span>';
    }

    $action_url = $action_file.'?seq='.$device['seq'].'&ip='.$device['ip'].'&port='.$device['port'].'&lang='.$_lang_code;
    if($local_action === false && $device['local'] == "N"){
      $action_url = "http://".$device['ip'].':'.$device['port'].$action_url;
    }

    $innerText .= '<li id="'.$device['seq'].'" data-ip="'.$device_addr.'" data-port="'.$device_port.'" data-name="'.$device['name'].'" data-order="'.$device['rowid'].'"
                   class="deviceItem '.$device_local_class.' '.$device_current_class.' '.$device_pending_class.'">';
    if($screen_view === true){
      $innerText .= '<strong title="'.$device_display_name_tooltip.'">'.$device_display_name.'</strong>
                     <img src="/public/images/blank.gif" alt="'.$device_display_name.'\'s current screen" class="current_screen" />
                     <a href="#screenAction" class="screenOverlay loading"><img src="/public/images/blank.gif" alt="" /></a>
                     <a href="#moreAction" class="more">'.msg('SCREENS_003').'<span>▼</span></a>';
    }else{
      $innerText .= '<a href="'.$action_url.'" title="'.$device_display_name_tooltip.'" class="name">'.$device_display_name.'</a>'.$device_pending_icon;
    }
    $innerText .= '</li>';
  }
}

$right_class = (count($device_list) > 1) ? 'narrow' : 'wide';
unset($device_list,$kvmDB);

$order_button = '
  <div id="sorting-options" data-cookieName="'.$cookie_name.'">
    <button type="button" id="sort-by-date" class="'.$date_active.'">'.msg('BTN_ORDERBY_DATE').'</button>
    <button type="button" id="sort-by-name" class="'.$name_active.'">'.msg('BTN_ORDERBY_NAME').'</button>
  </div>
';

if($screen_view === true){
  echo $order_button.'<ul id="items">'.$innerText.'</ul>';
}else{
  echo '<div id="center">'.$order_button.'<ul id="items" class="nav '.$section_class.'">'.$innerText.'</ul></div>';
}
unset($innerText,$order_button,$section_class);
?>
