<?php
/* *************************** *
 * KVM home index
 *
 * *************************** */
define("_KVM_", true);
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_check.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
//if(certifyDB() == false) initDB("output");
//else setupCheck();

setupCheck();

if(!$session_ok) {
  if($refresh_ok)
    echo '<html><head><meta charset="utf-8" /></head><body><script type="text/javascript">alert("'.msg('ALERT_SESSION_001').'");location.replace("/signout")</script></body></html>';
  else
    header('Location: /signout');
}
//하드디스크 없을시 녹화,미디어 메뉴 안보임
$hdd = getDiskInfo();
$is_hdd = $hdd['is_hdd'];
unset($hdd);
$current_firm_ver = isset($_SESSION["firmware_current_version"]) ? $_SESSION["firmware_current_version"] : "";
$new_firm_ver = isset($_SESSION["firmware_newest_version"]) ? $_SESSION["firmware_newest_version"] : "";

//로그인에서 넘어 왔을시에 처리할 일
$referer = isset($_SERVER['HTTP_REFERER']) ? parse_url($_SERVER['HTTP_REFERER']) : "no";
if($referer['host'] == $_SERVER['HTTP_HOST'] && strpos($referer['path'],'/signin') !== false){
  //backupLog();
  deleteOldDB('3m');
  //펌웨어검사관련
  /*
  if($_SESSION["user_type"] == "admin" || $_SESSION["user_type"] == "super"){
    if(is_file($_firmware_update_flag_file)){
      $firmware_arr = parse_ini_file($_firmware_update_flag_file);
      if($firmware_arr['ENABLE'] == true){
        execReboot(0);
      }elseif($firmware_arr['ENABLE'] == false){
        #새로운 펌웨어를 업데이트 할 준비가 되었습니다.
        $firmware_info = getFirmwareVersion("current");
        $current_firm_ver = $firmware_info['current_version'];
        $new_firm_ver = $firmware_arr['VERSION'];
      }
      unset($firmware_arr,$firmware_info);
    }else{
      $firmware_info = getFirmwareVersion("");
      $current_firm_ver = $firmware_info['current_version'];
      $new_firm_ver = $firmware_info['newest_version'];
    }
  }
  */
}
$locale = explode('-',$_lang_code);
//$locale = strtolower($locale[1]);

?><!DOCTYPE HTML>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
  <meta charset="utf-8" />
  <meta name="robots" content="noindex, noarchive, nofollow" />
  <meta name="viewport" content="width=980" />
  <title>RemoteKVM - <?=$_SESSION["device_display_name"]?></title>
  <link rel="Shortcut Icon" type="image/ico" href="/favicon.ico" />
  <link rel="stylesheet" media="screen, projection" type="text/css" href="/public/stylesheets/global.css" />
</head>

<body class="<?=$_lang_code?>">
<div id="kvmWrap">
  <div id="top">
    <div id="message"><?=msg('INDEX_001')?></div>
    <ul>
      <li><a href="/files/download/kvm_manual_kr.pdf" class="button-help"><span><?=msg('INDEX_002')?></span></a></li>
      <li><a href="/signout" class="button-signout"><span><?=msg('INDEX_003')?></span></a></li>
    </ul>
  </div>
  <div id="left">
    <div class="logo">
      <h1><a href="/">RemoteKVM</a></h1>
    </div>
    <ul class="nav" id="leftNav">
      <li data-name="screens" class="current"><a href="/screens/?lang=<?=$_SESSION["language"]?>" class="get"><?=msg("L_SCREENS")?></a></li>
      <li data-name="records"><a href="/records/?lang=<?=$_SESSION["language"]?>" class="get"><?=msg("L_RECORDS")?></a></li>
      <li data-name="logs"><a href="/logs/?lang=<?=$_SESSION["language"]?>" class="get"><?=msg("L_LOGS")?></a></li>
<? if($_SESSION["user_type"]=="admin"||$_SESSION["user_type"]=="super"){ ?>
      <li data-name="devices"><a href="/devices/?lang=<?=$_SESSION["language"]?>" class="set"><?=msg("L_DEVICES")?></a></li>
      <li data-name="users"><a href="/users/?lang=<?=$_SESSION["language"]?>" class="set"><?=msg("L_USERS")?></a></li>
<? } else { ?>
      <li data-name="account"><a href="/users/account.php?lang=<?=$_SESSION["language"]?>" class="set"><?=msg("L_ACCOUNT")?></a></li>
      <? } ?>
<? if($_SESSION["user_type"]=="super"){?>
      <li data-name="settings"><a href="/settings/?lang=<?=$_SESSION["language"]?>" class="set"><?=msg("L_SETTINGS")?></a></li>
<? } ?>
      <li data-name="downloads"><a href="/downloads/?lang=<?=$_SESSION["language"]?>" class="etc"><?=msg("L_DOWNLOADS")?></a></li>
      <li data-name="about"><a href="/about/?lang=<?=$_SESSION["language"]?>" class="etc"><?=msg("L_ABOUT")?></a></li>
    </ul>
<?php include $_SERVER['DOCUMENT_ROOT'].'/_common/version.php'; ?>
  </div>
  <div id="content"></div>
  <div id="loading" style="display: none;"></div>
</div>
<script type="text/javascript" src="/public/javascripts/jquery.min.js"></script>
<script type="text/javascript">
  $.kvm = {
    user: { name: '<?=$_SESSION["user_id"]?>', pw: '<?=$_SESSION["user_pw"]?>', seq: '<?=$_SESSION["user_seq"]?>', type: '<?=$_SESSION["user_type"]?>' },
    device: { seq: '<?=$_local_device_seq?>', name: '<?=$_local_device_name?>', ip: '<?=$_SERVER["SERVER_ADDR"]?>', port: '<?=$_SERVER["SERVER_PORT"]?>'},
    plugin: { latest: "<?=$_kvm_version?>" },
    <?php if($_SESSION["user_type"] == "supeeeer"){ ?>
    firmware: { current: '<?=$_kvm_version?>', latest: '<?=$_kvm_version?>' },
    <?php } ?>
    language: '<?=$_SESSION["language"]?>',
    device_display: '<?=$_device_display_type?>'
  };
</script>
<script type="text/javascript" src="/public/javascripts/localization.js.php"></script>
<script type="text/javascript" src="/public/javascripts/jquery.validate.js"></script>
<script type="text/javascript" src="/public/javascripts/kvm.base.js"></script>
<script type="text/javascript" src="/public/javascripts/kvm.system.js"></script>
</body>
</html>
<?php
  unset($referer);
?>
