/** *********************
 * KVM API TEST
 * 2012 05 18
 * author: Jeong Heeju
 ********************* */
(function(win,doc){
 
  /** ***********************
   * plugin functions
   ************************** */
  function plugin(){
    var pluginPath = ""
      , pluginCLSID = ""
      , pluginMimeType = "application/x-remotekvmplugin"
      , div = doc.createElement("div");
    div.style.cssText = "visibility:hidden;position:absolute;width:0;height:0;";
    doc.body.appendChild(div);
    if (navigator.appName == 'Microsoft Internet Explorer') {
      div.innerHTML = '<object id="plug-in" codebase="' + pluginPath + '" classid="' + pluginCLSID + '" type="' + pluginMimeType + 
                      '" style="margin:0; padding:0; width:100%; height:100%;"></object>';
    }else{
      div.innerHTML = '<embed id="plug-in" pluginspage="' + pluginPath + '" type="' + pluginMimeType + 
                      '" style="margin:0; padding:0; width:100%; height:100%;"></embed>';
    }
    return doc.getElementById('plug-in');
  }
  
  function checkPlugin(address){
    if (plugin.installed === undefined) plugin.installed = plugin();
    if (plugin.installed && plugin.installed.valid){
      //if((plugin.installed.version != -1 && plugin.installed.version == '')){
      if((plugin.installed.version != -1)) return true;
      else plugin.errorMessage = 'Plugin Updated';
    }else{
      plugin.errorMessage = 'Plugin is not installed. Download plugin now?';
    }
    if(plugin.errorMessage && confirm(plugin.errorMessage)){
      location.href = "http://"+address+"/files/download/kvm_setup.exe";
    }
    return false;
  }
  
  function kvm(address,targetId){
    var target = this.target = doc.getElementById(targetId);
    this.address = address;
    this.target.innerHTML = '<span style="display:inline-block;width:234px;height:156px;overflow:hidden;background-color:#000;'+
                            'color:#fff;font-size:20px;line-height:156px;text-align:center">'+
                            'Wait a Momemt..</span>';
    this.getStatus();
  }
  
  kvm.prototype = {
    "getStatus": function(){
      this.getstatusTimeout && clearTimeout(this.getstatusTimeout);
      
      var script = doc.createElement('SCRIPT')
        , callback = 'api_'+new Date().getTime()+Math.floor(Math.random()*999)+1
        , _this = this;
          
      doc.body.appendChild(script);
      script.setAttribute('src','http://'+this.address+'/screens/read.php?callback='+callback);
      this.loadscriptTimeout = setTimeout(loadTimeout,6000);
      
      function loadTimeout(){
        _this.status = "disconnected";
        win[callback] = null;
        script.parentNode.removeChild(script);
        console.error('loading error:',_this.address);
        _this.preview();
      }
      
      win[callback] = function(data){
        _this.loadscriptTimeout && clearTimeout(_this.loadscriptTimeout);
        _this.status = (typeof data == 'string') ? data : data.status;
        script.parentNode.removeChild(script);
        win[callback] = null;
        _this.preview();
        _this.getstatusTimeout = setTimeout(function(){_this.getStatus()},10000);
      }
      
    },
    "preview": function(){
      this.target.innerHTML = {
        'normal' : [
          '<a href="javascript:kvmRemote(\''+this.address+'\')" style="display:inline-block;width:234px;height:156px;overflow:hidden;border:0;">',
            '<img src="http://'+this.address+'/screens/screen.php#'+new Date().getTime()+'" '+
            'alt="" style="display:inline-block;width:234px;height:156px;border:0;" />',
          '</a>'
        ].join('\n'),
        'error' : [
          '<span style="display:inline-block;width:234px;height:156px;overflow:hidden">',
            '<img src="http://'+this.address+'/public/images/screen_error.png" alt="" style="display:inline-block;width:234px;height:156px;border:0;" />',
          '</span>'
        ].join('\n'),
        'disconnected' : [
          '<span style="display:inline-block;width:234px;height:156px;overflow:hidden;background-color:#000;color:#fff;font-size:20px;'+
          'line-height:156px;text-align:center">',
            'Disconnected',
          '</span>'
        ].join('\n')
      }[this.status];
    }
  }

  win.kvmView = function(address,targetId){
    if(!address || !targetId || !doc.getElementById(targetId)) return false;
    var this_kvm = new kvm(address,targetId);
  }

  win.kvmRemote = function(address){
    if(checkPlugin(address)){
      plugin.installed.RunCommand('rtsp://' + address + '|', 'REMOTEKVM');
    }
  }

})(this,document);