/**
 * RemoteKVM - base.js
 *
 * @author firejune(to@firejune.com)
 * @copyright © 2011 RSUPPORT. CO, LTD. All rights Reserved.
 *
 */

(function($, win, doc) {

  // for console debugging
  var emptyFunction = function() {};
  if (win['console'] === undefined || console.log === undefined)
    console = {log: emptyFunction, info: emptyFunction, warn: emptyFunction, error: emptyFunction};
  //else if (!location.href.match('192.168'))
    //console.log = console.info = console.warn = console.error = function() {};
  /*
   * jQuery touchscroll plugin
   *
   */

  $.fn.touchscroll = function () {
    var ua = navigator.userAgent, multipleTouch = false;
    if (!(ua.match(/iPhone/i) || ua.match(/iPod/i) || ua.match(/iPad/i))) return this;

    //$(this).css({'overflow': 'auto','position':'relative'});

    return this.each(function() {
      var cont = $(this);
      var scrollbar = $('<div id="scroller"/>').css({
        display: 'none',
        position: 'absolute',
        background: '#000',
        top: 0,
        width: 8,
        right: 7,
        borderRadius: 4,
        opacity: .5
      });

      cont.bind('touchstart',function(ev) {
        var innerHeight = cont.innerHeight();
        var scrollHeight = cont.attr('scrollHeight');
        multipleTouch = ev.originalEvent.touches.length > 1;
        if (scrollHeight < innerHeight + 8 || multipleTouch) return true;

        var visibled = false;
        var pageY = ev.originalEvent.touches[0].pageY;
        var scrollTop = cont.scrollTop();
        var scrollbarHeight = innerHeight * (innerHeight / scrollHeight);

        cont.bind('touchmove', function(event) {
          if (multipleTouch) return true;

          event.preventDefault();
          event = event.originalEvent.touches[0];

          if (!visibled) {
            !cont.find('#scroller').length && cont.append(scrollbar);
            scrollbar.css({height: scrollbarHeight - 8}).show();
            visibled = true;
          }

          cont.scrollTop(scrollTop -= event.pageY - pageY);
          if (scrollTop < 0) scrollTop = 0;
          pageY = event.pageY;
          scrollbar.css({top: Math.min(scrollTop + scrollTop * innerHeight / scrollHeight, scrollHeight - scrollbarHeight) + 4});
        });

        cont.bind('touchend',function(event) {
          cont.unbind('touchmove touchend');
          scrollbar.hide();
        });
      });
    });
  };

  var $body = $(doc.body)
    , $win = $(win)
    // 플랫폼 검사
    , $suckBrowser = $.browser.msie && $.browser.version <= 6
    , $fuckBrowser = $.browser.msie && $.browser.version <= 7
    , $platform = (function (platforms) {

      for (var i = 0; i < platforms.length; i++)
        if (platforms[i].string && platforms[i].string.indexOf(platforms[i].subString) != -1)
          return platforms[i].identity;

      return null;

    })([
      { string: navigator.platform, subString: "Win", identity: "Win" },
      { string: navigator.platform, subString: "Mac", identity: "Mac" },
      { string: navigator.platform, subString: "Linux", identity: "Lin" },
      { string: navigator.userAgent, subString: "iPhone", identity: "iOS" }
    ])

  /**
   * resize handler for layout
   */
  $win.resize(function() {
    var left = ($win.width() - 980) / 2;
    var content = $('#content');
    var right = $('#right');
    //var offset = content.prop('offsetHeight') < content.prop('scrollHeight') ? 18 : 0;
    //left < 0 && $('#top').css('right', 50 - left * 2);
    content.css({
      //'width': left < 0 ? right.css('width', '').width() + left * 2 : '',
      "height": $win.height(),
      "padding-right": left >= 18 ? left : 18
    });
  }).resize();

  $platform == "iOS" && $win.load(function () {
    $('#right').live('touchstart', function() {
      !this.touchscroll && $(this).touchscroll();
      this.touchscroll = true;
    });
    (window.onorientationchange = function (top) {
      top && setTimeout(scrollTo, 0, 0, 1);
    })(true);
  });

  // for IE
  if (!Array.prototype.indexOf)
    Array.prototype.indexOf = function(searchElement /*, fromIndex */) {
      if (this === void 0 || this === null) throw new TypeError();
      var t = Object(this);
      var len = t.length >>> 0;
      if (len === 0) return -1;
      var n = 0;
      if (arguments.length > 0) {
        n = Number(arguments[1]);
        if (n !== n) n = 0; // shortcut for verifying if it's NaN
        else if (n !== 0 && n !== (1 / 0) && n !== -(1 / 0)) n = (n > 0 || -1) * Math.floor(Math.abs(n));
      }

      if (n >= len) return -1;
      var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);

      for (; k < len; k++) if (k in t && t[k] === searchElement) return k;
      return -1;
    };

})(jQuery, window, document);
