<?php
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

$hdd = getDiskInfo();
$is_hdd = $hdd['is_hdd'];
unset($hdd);

$web_addr = $_SERVER["HTTP_HOST"];
$record_path = $_SERVER['DOCUMENT_ROOT']."/files/record/";
$record_web_path = "http://".$web_addr."/files/record/";

if($is_hdd != 'Y' || is_dir($record_path) === false){
  $innerText = '<tr><td colspan="4" style="height:200px;">
                <p class="error" style="font:bold 20px sans-serif;color:#F20;padding:80px 0;text-align:center;">'.msg('RECORDS_003').'</p>
                </td></tr>';
}else{
  $kvmDB = new kvmDB();
  $logDB = new kvmDB($_db_path_logs);
  $innerText = $last_index = "";

  $count = isset($_GET["count"]) ? $_GET["count"] : "50";
  $start_num_sql = "";

  if(isset($_GET["date"])) {
    $date_arr = explode("-",$_GET["date"]);
    $start_num_sql = "AND start_time <= '".mktime(0,0,0,$date_arr[1],$date_arr[2]+1,$date_arr[0])."'";
  }
  elseif(isset($_GET["start"])) $start_num_sql =  "AND start_time < '".preg_replace("/[^\d]/","",$_GET["start"])."'";

  try{
    $recordDB = new kvmDB($_db_path_records);
    $first_date = $recordDB->getDataSingle("SELECT start_time FROM files_tbl
                                            WHERE record_mode > 1
                                            AND end_time > start_time
                                            AND size > 0
                                            ORDER BY start_time ASC LIMIT 1");
    $first_date = date('Y-m-d',$first_date);
    $rs = $recordDB->getData("SELECT fname,size,start_time,end_time,width,height,record_mode
                              FROM files_tbl
                              WHERE record_mode > 1
                                ".$start_num_sql."
                                AND end_time > start_time
                                AND size > 0
                              ORDER BY start_time DESC
                              LIMIT ".$count);

    while($data = $rs->fetchArray(SQLITE3_ASSOC)){

      //if(is_file($data['fname'])){

        $record_file_path = dirname($data['fname']);
        $record_file_name = basename($data['fname']);

        $record_file_name_array = explode("_",str_replace(".ts", "", $record_file_name));
        $record_file_path = "/files/record/".$record_file_name_array[0]."/".$record_file_name_array[1]."/";

        $record_length = $data['end_time'] - $data['start_time'];

        $record_length_sec = $record_length % 60;
        $record_length_min = (($record_length - $record_length_sec) / 60 ) % 60;
        $record_length_hour = ($record_length - $record_length_min*60 - $record_length_sec) / 3600;

        $record_length = "";
        if($record_length_hour > 0) $record_length .= $record_length_hour."h ";
        if($record_length_min > 0) $record_length .= $record_length_min."m ";
        if($record_length_sec > 0) $record_length .= $record_length_sec."s";

        $record_date = date("Y-m-d",$data['start_time']);
        $record_size = ($data['size'] > 1048575) ? round($data['size']/1048576,2).'MB' : round($data['size']/1024,2).'KB';
        $record_state = $remote_user = "";
        if($data['record_mode'] == 3){
          $record_state = 'remote';
          $remote_user_seq = $logDB->getDataSingle("SELECT user FROM logs_data
                                                    WHERE kind = 'K_REMOTE'
                                                      AND time > '".date('Y-m-d H:i:s',$data['start_time']-5)."'
                                                      AND time < '".date('Y-m-d H:i:s',$data['start_time']+5)."' LIMIT 1");
          $remote_user = $kvmDB->getDataSingle("SELECT id FROM users_data WHERE seq = '".$remote_user_seq."'");
        }


        $record_resolution =
          ($data['width'] == 0)
            ? msg('RECORDS_014') :
          ($data['width'] == '1631' || $data['width'] == '1825') ?
            '1920x'.$data['height'].'<span class="exception">*</span><span class="original-resolution">('.$data['width'].'x'.$data['height'].')</span>':
            $data['width'].'x'.$data['height'];

        $record_snapshot = "";
        $snapshot_list = glob($_SERVER['DOCUMENT_ROOT'].$record_file_path."/*.jpg");
        natsort($snapshot_list);

        $alt = $data['start_time']+2;
        if(count($snapshot_list) > 0){
          foreach($snapshot_list as $jpg){
            $jpg = basename($jpg);
            $record_snapshot .= '<img src="/public/images/blank.gif" alt="'.date("H:i:s",$alt).'" data-src="http://'.$web_addr.$record_file_path.$jpg.'" />';
            $alt += 300;
          }
        }else{
          $record_snapshot = '<img src="/public/images/nosnapshot.jpg" alt="No snapshot" />';
        }
        $innerText .= '
          <tr class="summary '.$record_state.'" data-date="'.$record_date.'" data-user="'.$remote_user.'">
            <td class="time">'.date("Y-m-d H:i:s",$data['start_time']).' ~ '.date("Y-m-d H:i:s",$data['end_time']).'</td>
            <td class="length">'.$record_length.'</td>
            <td class="resolution">'.$record_resolution.'</td>
            <td class="size">'.$record_size.'</td>
          </tr>
          <tr class="detail" data-date="'.$record_date.'" data-file-name="'.$record_file_name.'" data-file-path="'.$record_file_path.'">
            <td colspan="4">
              '.$record_snapshot.'
            </td>
          </tr>
        ';
        $last_index = $data['start_time'];
      //}
    }
    $innerText .='<tr id="lastRow" data-addr="'.$_SERVER["HTTP_HOST"].'" data-last-index="'.$last_index.'" data-first-date="'.$first_date.'"><td colspan="4"></td></tr>';

    unset($recordDB);
  }
  catch(Exception $e){
    print_r($e);
  }
  unset($kvmDB,$logDB);
}
if(isset($_REQUEST["callback"])){
  header("Content-type:text/javascript; charset=utf-8");
  $innerText = json_encode($innerText);
  echo $_REQUEST["callback"]."(".$innerText.")";
}else{
  echo $innerText;
}
unset($innerText);

?>
