<?php
  $_this_target = "LOCATION#L_SETTINGS_GENERAL";
  if(!defined("_KVM_SETTING")){
    require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
    $access_try_user = (empty($_SESSION['user_seq'])) ? "unknown" : $_SESSION['user_seq'];
    inputLog("WARNING", "L_SETTINGS", $_this_target, "K_ACCESS", $access_try_user, "CODE_SETTING_011", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">ACCESS ERROR!</p>');
  }

  //이전 값 비교

  $rs = $kvmDB->getData("SELECT language,device_display,pc_type,pc_mac FROM preference");
  if($row = $rs->fetchArray()){
    $language = $row['language'];
    $device_display = $row['device_display'];
    $pc_type = $row['pc_type'];
    $pc_mac = $row['pc_mac'];
  }
  unset($rs,$row);
  $res = false;
  $_add_log_message = "";

  //POST로 들어온 값이 있으면
  if(isset($_POST['language']) && $language != $_POST['language']){
    $_SESSION["language"] = $_POST['language'];
    $_add_log_message .= " * Language : ".$language." → ".$_POST['language']."\n";
    $language = $_POST['language'];
    $res = true;
  }

  if(isset($_POST['device_display']) && $device_display != $_POST['device_display']){
    $_SESSION["device_display_type"] = $_POST['device_display'];
    $_SESSION["device_display_name"] = ($_POST['device_display'] == "ip") ? $_SESSION["device_ip"] : $_SESSION["device_name"];
    $_add_log_message .= " * Device Display Type : ".$device_display." → ".$_POST['device_display']."\n";
    $device_display = $_POST['device_display'];
    $res = true;
  }

  if(isset($_POST['pc_type']) && $pc_type != $_POST['pc_type']){
    $pc_table = array(
      "0" => "Windows/Linux",
      "1" => "Mac OSX"
    );
    $_SESSION["pc_type"] = $_POST['pc_type'];
    $_add_log_message .= " * PC OS Type : ".$pc_table[$pc_type]." → ".$pc_table[$_POST['pc_type']]."\n";
    $pc_type = $_POST['pc_type'];
    $res = true;
  }

  if(isset($_POST['pc_mac']) && $pc_mac != $_POST['pc_type']){
    $change_mac_value = ($_POST['pc_mac'] == "") ? 'none' : $_POST['pc_mac'];
    $current_mac_value = ($pc_mac == "") ? 'none' : $pc_mac;
    $_add_log_message .= " * PC MAC Address : ".$current_mac_value." → ".$change_mac_value."\n";
    $pc_mac = $_POST['pc_mac'];
    $res = true;
  }

  if($res){
    $res2 = $kvmDB->setData("UPDATE preference SET
                                  language = '".$_POST['language']."',
                                  device_display = '".$_POST['device_display']."',
                                  pc_type = '".$_POST['pc_type']."',
                                  pc_mac = '".$_POST['pc_mac']."'"
                           );
    if($res2){
      inputLog("INFO", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_001", $_add_log_message);
    }
    else{
      inputLog("ERROR", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_002", "");
      $kvmJson->setJsonData("fieldName", "");
       $kvmJson->setJsonData("statusText", msg("ALERT_SETTING_002"));
       $kvmJson->setJsonData("statusType", "error");
       header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }
    exit();
  }
  $langEN = $langCN = $langTW = $langJP = $langKR = "";
  switch($language){
    case "en-US": $langEN = $selected; break;
    case "zh-CN": $langCN = $selected; break;
    case "zh-TW": $langTW = $selected; break;
    case "ja-JP": $langJP = $selected; break;
    case "ko-KR": $langKR = $selected; break;
  }

  $display_ip = $display_name = "";
  switch($device_display){
    case "ip": $display_ip = $selected; break;
    case "name": $display_name = $selected; break;
  }

  $pc_type_win = $pc_type_mac = "";
  switch($pc_type){
    case "0": $pc_type_win = $selected; break;
    case "1": $pc_type_mac = $selected; break;
  }
?>
  <fieldset>
    <legend><?=msg('SETTINGS_101')?></legend>
    <p>
      <?=msg('SETTINGS_102A')?><br>
      <?=msg('SETTINGS_102B')?>
    </p>
    <label><?=msg('SETTINGS_103')?></label>
    <select name="language">
      <option value="en-US"<?=$langEN?>><?=msg("ENGLISH")?></option>
      <option value="ko-KR"<?=$langKR?>><?=msg("KOREAN")?></option>
      <option value="ja-JP"<?=$langJP?>><?=msg("JAPANESE")?></option>
      <option value="zh-CN"<?=$langCN?>><?=msg("SIMCHINESE")?></option>
      <option value="zh-TW"<?=$langTW?>><?=msg("TRACHINESE")?></option>
    </select>
  </fieldset>

  <fieldset>
    <legend><?=msg('SETTINGS_104')?></legend>
    <p><?=msg('SETTINGS_105')?></p>
    <label><?=msg('SETTINGS_106')?></label>
    <select name="device_display">
      <option value="name"<?=$display_name?>><?=msg('SETTINGS_107')?></option>
      <option value="ip"<?=$display_ip?>><?=msg('SETTINGS_108')?></option>
    </select>
  </fieldset>

  <fieldset class="last">
    <legend><?=msg('SETTINGS_109')?></legend>
    <p><?=msg('SETTINGS_110')?></p>
    <label><?=msg('SETTINGS_111')?></label>
    <select name="pc_type">
      <option value="0"<?=$pc_type_win?>><?=msg('SETTINGS_112')?></option>
      <option value="1"<?=$pc_type_mac?>><?=msg('SETTINGS_113')?></option>
    </select>
    <p><?=msg('SETTINGS_114')?></p>
    <label><?=msg('SETTINGS_115')?></label>
    <input type="text" name="pc_mac" value="<?=$pc_mac?>" maxlength="17" />
  </fieldset>
