<?php
  header("Cache-Control: no-cache");
  header("Pragma: no-cache");
  define("_KVM_SETTING", true);
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_check.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/ini.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/json.php';

  $_this_location = "L_SETTINGS";
  $_this_user = $_SESSION['user_seq'];

  //if(!isset($_SESSION['user_type']) || ($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super")){
  if(!isset($_SESSION['user_type']) || $_SESSION['user_type'] != "super"){
    inputLog("WARNING", $_this_location, "", "K_ACCESS", $_this_user, "CODE_SETTING_010", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">Permision Not Denied.</p>');
  }

  $kvmDB = new kvmDB();
  $kvmJson = new kvmJson();

  $selected = ' selected="selected"';
  $class_current = ' class="current"';

  $hdd = getDiskInfo();
  $is_hdd = $hdd['is_hdd'];
  $hdd_abailable = "0";
  $hdd_used = "0";
  $hdd_total = "0";
  $hdd_percent = "0";
  if($is_hdd == 'Y'){
    $hdd_total = round($hdd['total']/1048576,2);
    $hdd_abailable = round($hdd['available']/1048576,2);
    $hdd_used = round($hdd['used']/1048576,2);
    $hdd_percent = $hdd['percent'];
  }
  unset($hdd);

  $mode = isset($_REQUEST["mode"]) ? $_REQUEST["mode"] : "general";
  $current_general = $current_firmware = $current_medias = $current_record = $current_database = $current_security =
  $current_system = $current_downloads = $current_about = $current_rview = "";
  $is_multipart = false;
  switch($mode){
    case "general" :
      $include_file = "general.php";
      $current_general = $class_current;
    break;

    case "firmware" :
      $include_file = "firmware.php";
      $current_firmware = $class_current;
      $is_multipart = true;
    break;

    case "medias" :
      $include_file = "medias.php";
      $current_medias = $class_current;
    break;

    case "record" :
      $include_file = "record.php";
      $current_record = $class_current;
    break;

    case "database" :
      $include_file = "database.php";
      $current_database = $class_current;
      $is_multipart = true;
    break;

    case "security" :
      $include_file = "security.php";
      $current_security = $class_current;
    break;

    case "system" :
      $include_file = "system.php";
      $current_system = $class_current;
    break;

    case "downloads" :
      $include_file = "downloads.php";
      $current_downloads = $class_current;
      $is_multipart = true;
    break;

    case "about" :
      $include_file = "about.php";
      $current_about = $class_current;
    break;

    case "rview" :
      $include_file = "rview.php";
      $current_rview = $class_current;
    break;

    default:
      $include_file = "general.php";
      $current_general = $class_current;
    break;
  }

  $multipart_attr = '';
  if($is_multipart == true) $multipart_attr = 'enctype="multipart/form-data" target="iframe"';

  if(isset($_POST['modify']) && $_POST['modify'] == 'Y'){
    if(is_file($_SERVER['DOCUMENT_ROOT'].'/settings/'.$mode.".php")) include_once $_SERVER['DOCUMENT_ROOT'].'/settings/'.$mode.".php";
    exit();
  }
?>
<div id="center">
  <ul class="nav">
    <li<?=$current_general?> data-name="general"><a href="/settings/?mode=general&lang=<?=$_SESSION["language"]?>" class="name"><?=msg("L_SETTINGS_GENERAL")?></a></li>
    <? if($is_hdd=="Y"){ ?>
    <!-- li<?=$current_medias?> data-name="medias"><a href="/settings/?mode=medias" class="name"><?=msg("L_SETTINGS_MEDIAS")?></a></li -->
    <li<?=$current_record?> data-name="record"><a href="/settings/?mode=record" class="name"><?=msg("L_SETTINGS_RECORD")?></a></li>
    <? } ?>
<?php if($_SESSION['user_type'] == 'super'){ ?>
    <li<?=$current_system?> data-name="system"><a href="/settings/?mode=system&lang=<?=$_SESSION["language"]?>" class="name"><?=msg("L_SETTINGS_SYSTEM")?></a></li>
    <!-- li<?=$current_security?> data-name="security"><a href="/settings/?mode=security" class="name"><?=msg("L_SETTINGS_SECURITY")?></a></li -->
<?php } ?>
    <li<?=$current_database?> data-name="database"><a href="/settings/?mode=database&lang=<?=$_SESSION["language"]?>" class="name"><?=msg("L_SETTINGS_DATABASE")?></a></li>
    <li<?=$current_firmware?> data-name="firmware"><a href="/settings/?mode=firmware&lang=<?=$_SESSION["language"]?>" class="name"><?=msg("L_SETTINGS_FIRMWARE")?></a></li>
<?php //if(isset($_REQUEST['rview']) && $_REQUEST['rview'] == 'y'){ ?>
    <li<?=$current_rview?> data-name="rview"><a href="/settings/?mode=rview&lang=<?=$_SESSION["language"]?>" class="name"><?=msg("L_SETTINGS_RVIEW")?></a></li>
<?php //} ?>
  </ul>
</div>

<div id="right" class="narrow <?=$mode?>">
  <form action="/settings/index.php" class="main settings" id="settings" method="post" <?=$multipart_attr?>>
    <input type="hidden" name="mode" value="<?=$mode?>"/>
    <input type="hidden" name="modify" value="Y"/>

    <?php
      if(is_file($_SERVER['DOCUMENT_ROOT'].'/settings/'.$mode.".php")){
        include_once $_SERVER['DOCUMENT_ROOT'].'/settings/'.$mode.".php";
      }else{
        echo '<p style="font-size:24px; line-height:1.6; color:red;">ERROR!!<br />Invalid Request Parameter.</p>';
      }
    ?>

    <div class="buttons">
      <input type="submit" class="button apply dim" value="<?=msg('BTN_APPLY')?>"/>
      <a href="#addAddress" class="button insert" id="add-address" title="">+</a>
    </div>
  </form>
  <iframe name="iframe" id="iframe" frameborder="0" width="0" height="0"></iframe>
</div>
<?php
  unset($kvmDB,$kvmJson);
?>
