<?php
  $_this_target = "LOCATION#L_SETTINGS_MEDIAS";
  if(!defined("_KVM_SETTING")){
    require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
    $access_try_user = (empty($_SESSION['user_seq'])) ? "unknown" : $_SESSION['user_seq'];
    inputLog("WARNING", "L_SETTINGS", $_this_target, "K_ACCESS", $access_try_user, "CODE_SETTING_011", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">ACCESS ERROR!</p>');
  }

  if($is_hdd != "Y"){
    inputLog("WARNING", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_015", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">NO HDD!</p>');
  }

  //istreamer설정파일
  $istremer_select_disabled = '';
  $ini = new INIManager($_istreamer_config_file);
  if(!$ini->Initialize(false)){
     $istremer_select_disabled = ' disabled="disabled"';
     $istremer_select_error = '<option selected="selected">'.msg('SETTINGS_315').'</option>';
  }else{
    $arrGet = $ini->getINIData();

    $media_quality = $arrGet["BSP_HEIGHT"];
    $media_length = $arrGet["period"];
    $snapshot_term = $arrGet["snapshot"];

    unset($arrGet);
  }
  unset($ini);

  //파일 삭제설정파일
  $ini = new INIManager($_eraser_config_file);
  $global_array = array();
  $section_array = array();
  $eraser_select_disabled = '';
  if(!$ini->Initialize(true)){
     $eraser_select_disabled = ' disabled="disabled"';
     $eraser_select_error = '<option selected="selected">'.msg('SETTINGS_315').'</option>';
  }else{
    $arrGet = $ini->getINIData();
    $active_section = explode(",",$arrGet['Global']['ActiveSections']);

    $large_space = $arrGet[$active_section[0]]['LargeSpace'];
    $keep_day = $arrGet[$active_section[0]]['KeepPeriod'];
    $low_space = $arrGet[$active_section[0]]['LowSpace'];

    unset($arrGet,$active_section);
  }
  unset($ini);

  //설정파일 쓰기
  $_add_log_message = "";
  $res_media = false;
  $res_eraser = false;
  $res_ok = false;

  //미디어 크기관련
  if(isset($_POST['media_quality']) && $_POST['media_quality'] != $media_quality){
    switch($_POST['media_quality']){
      case "1080": $media_width = "1920"; break;
      case "720" : $media_width = "1280"; break;
      case "480" : $media_width = "720";  break;
      case "360" : $media_width = "640";  break;
      case "240" : $media_width = "360";  break;
    }
    $_add_log_message .= " * Media Quality : ".$media_quality."p → ".$_POST['media_quality']."p\n";
    $media_quality = $_POST['media_quality'];
    $res_media = true;
  }

  //녹화 길이
  if(isset($_POST['media_length']) && $_POST['media_length'] != $media_length){
    $_add_log_message .= " * Media Length : ".$media_length."s → ".$_POST['media_length']."s\n";
    $media_length = $_POST['media_length'];
    $res_media = true;
  }

  //스냅샷
  if(isset($_POST['snapshot_term']) && $_POST['snapshot_term'] != $snapshot_term){
    $_add_log_message .= " * Snapshot Term : ".$snapshot_term."s → ".$_POST['snapshot_term']."s\n";
    $snapshot_term = $_POST['snapshot_term'];
    $res_media = true;
  }

  //파일삭제 파일 유지 지간
  if(isset($_POST['keep_day']) && $_POST['keep_day'][0] != $keep_day){
    $_add_log_message .= " * Record Keep Days : ".$keep_day."s → ".$_POST['keep_day'][0]."s\n";
    $keep_day = $_POST['keep_day'][0];
    $res_eraser = true;
  }

  //파일삭제 디스크 여유공간
  if(isset($_POST['low_space']) && $_POST['low_space'][0] != $low_space){
    $_add_log_message .= " * Free Disk Space : ".$low_space." → ".$_POST['low_space'][0]."\n";
    $low_space = $_POST['low_space'][0];
    $res_eraser = true;
  }

  //미디어 설정파일 쓰기
  if($res_media === true){
    $ini = new INIManager($_istreamer_config_file);
    if(!$ini->Initialize(true)){
      inputLog("ERROR", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_004", "");
      $kvmJson->setJsonData("fieldName", "");
       $kvmJson->setJsonData("statusText", msg("ALERT_SETTING_004"));
       $kvmJson->setJsonData("statusType", "error");
       header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }else{
      $arrData = $ini->getINIData();

      $arrData['Global']['BSP_WIDTH'] = $media_width;
      $arrData['Global']['BSP_HEIGHT'] = $_POST['media_quality'];
      $arrData['Global']['BSP_PASSTHRU'] = "OFF";
      $arrData['Global']['BSP_AUDIO'] = "none";

      //$arrData['Record']['enable'] = ($arrData['Record']['enable'] == 1) ? "yes" : "no";
      $arrData['Record']['enable'] = "yes";
      $arrData['Record']['period'] = $_POST['media_length'];
      $arrData['Record']['repeat'] = ($arrData['Record']['repeat'] == 1) ? "yes" : "no";
      //$arrData['Record']['snapshot'] = $_POST['snapshot_term'];
      $arrData['Record']['snapshot'] = '5min';

      $ini->setINIData($arrData);
      $ini->writeINI_Section();
      unset($arrData);
      $res_ok = true;
    }
    unset($ini);
  }

  //삭제 설정파일 쓰기
  if($res_eraser === true){
    $ini = new INIManager($_eraser_config_file);
    if(!$ini->Initialize(true)){
      inputLog("ERROR", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_005", "");
      $kvmJson->setJsonData("fieldName", "");
       $kvmJson->setJsonData("statusText", msg("ALERT_SETTING_005"));
       $kvmJson->setJsonData("statusType", "error");
       header("HTTP/1.0 500 Menual Error");
      exit($kvmJson->getJsonEncode());
    }else{
      $arrData = $ini->getINIData();

      $section = $_POST['eraser_section'];
      $post_low_space = $_POST['low_space'];
      $post_keep_day = $_POST['keep_day'];

      $sections = "";
      for($i = 0; $i < count($section); $i++){
        $sections .= $section[$i].",";
        $arrData[$section[$i]]["Directory"] = $arrData[$section[$i]]["Directory"];
        $arrData[$section[$i]]["Filter"] = $arrData[$section[$i]]["Filter"];
        $arrData[$section[$i]]["LowSpace"] = $post_low_space[$i];
        $arrData[$section[$i]]["LargeSpace"] = $arrData[$section[$i]]["LargeSpace"];
        $arrData[$section[$i]]["KeepPeriod"] = $post_keep_day[$i];
        $arrData[$section[$i]]["CheckPeriod"] = $arrData[$section[$i]]["CheckPeriod"];
      }
      $arrData["Global"]["ActiveSections"] = substr($sections, 0,-1);

      $ini->setINIData($arrData);
      $ini->writeINI_Section();
      unset($arrData,$sections,$section,$post_low_space,$post_keep_day);
      $res_ok = true;
    }
    unset($ini);
  }

  if($res_ok === true){
    exec("killall istreamer");
    inputLog("INFO", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_003", $_add_log_message);
  }


  $size_1080 = $size_720 = $size_480 = $size_360 = $size_240 = "";
  switch($media_quality){
    case "1080": $size_1080 = $selected; break;
    case "720" : $size_720  = $selected; break;
    case "480" : $size_480  = $selected; break;
    case "360" : $size_360  = $selected; break;
    case "240" : $size_240  = $selected; break;
  }
  $length_30 = $length_60 = $length_120 = "";
  switch($media_length){
    case "30min" : $length_30  = $selected; break;
    case "60min" : $length_60  = $selected; break;
    case "120min": $length_120 = $selected; break;
  }
  $snapshot_5 = $snapshot_10 = $snapshot_30 = "";
  switch($snapshot_term){
    case "5min" : $snapshot_5  = $selected; break;
    case "10min": $snapshot_10 = $selected; break;
    case "30min": $snapshot_30 = $selected; break;
  }
  $keep_days_10 = $keep_days_20 = $keep_days_30 = $keep_days_40 = $keep_days_50 = $keep_days_60 = "";
  switch($keep_day){
    case "10day": $keep_days_10 = $selected; break;
    case "20day": $keep_days_20 = $selected; break;
    case "30day": $keep_days_30 = $selected; break;
    case "40day": $keep_days_40 = $selected; break;
    case "50day": $keep_days_50 = $selected; break;
    case "60day": $keep_days_60 = $selected; break;
  }
  $low_space_5 = $low_space_10 = $low_space_20 = "";
  switch($low_space){
    case "5%" : $low_space_5  = $selected; break;
    case "10%": $low_space_10 = $selected; break;
    case "20%": $low_space_20 = $selected; break;
  }

?>
  <fieldset>
    <legend><?=msg('SETTINGS_301')?></legend>
    <div class="progress"><div class="bar" style="width:<?=$hdd_percent?>%;"></div></div>
    <p class="hdd_info">
      used <b style="color:#9E011F"><?=$hdd_used?>GB</b> /
      total <b style="color:#7CADE4"><?=$hdd_total?>GB</b> /
      available <b style="color:#F39336"><?=100-$hdd_percent?>%</b>
    </p>
  </fieldset>

  <fieldset>
    <legend><?=msg('SETTINGS_304')?></legend>
    <p><?=msg('SETTINGS_305')?></p>
    <label><?=msg('SETTINGS_306')?></label>
    <select name="media_quality" <?=$istremer_select_disabled?>>
      <?=$istremer_select_error?>
      <option value="1080"<?=$size_1080?>>1080p</option>
      <option value="720"<?=$size_720?>>720p</option>
      <option value="480"<?=$size_480?>>480p</option>
      <option value="360"<?=$size_360?>>360p</option>
      <option value="240"<?=$size_240?>>240p</option>
    </select>

    <label><?=msg('SETTINGS_307')?></label>
    <select name="media_length" <?=$istremer_select_disabled?>>
      <?=$istremer_select_error?>
      <option value="30min"<?=$length_30?>>30 <?=msg('DATE_MINUTES')?></option>
      <option value="60min"<?=$length_60?>>1 <?=msg('DATE_HOUR')?></option>
      <option value="120min"<?=$length_120?>>2 <?=msg('DATE_HOURS')?></option>
    </select>
  </fieldset>

  <!-- fieldset>
    <legend><?=msg('SETTINGS_308')?></legend>
    <p><?=msg('SETTINGS_309')?></p>
    <label><?=msg('SETTINGS_310')?></label>
    <select name="snapshot_term" <?=$istremer_select_disabled?>>
      <?=$istremer_select_error?>
      <option value="5min"<?=$snapshot_5?>>5 Minutes</option>
      <option value="10min"<?=$snapshot_10?>>10 Minutes</option>
      <option value="30min"<?=$snapshot_30?>>30 Minutes</option>
    </select>
  </fieldset -->

  <fieldset class="last">
    <legend><?=msg('SETTINGS_311')?></legend>
    <input type="hidden" name="eraser_section[]" value="DEFAULT" />
    <p><?=msg('SETTINGS_312A')?><br />
       <?=msg('SETTINGS_312B')?> <?=$large_space?> <?=msg('SETTINGS_312C')?><br />
       <?=msg('SETTINGS_312D')?><br />
    </p>
    <label><?=msg('SETTINGS_313')?></label>
    <select name="keep_day[]" <?=$eraser_select_disabled?>>
      <?=$eraser_select_error?>
      <option value="10day"<?=$keep_days_10?>>10 <?=msg('DATE_DAYS')?></option>
      <option value="20day"<?=$keep_days_20?>>20 <?=msg('DATE_DAYS')?></option>
      <option value="30day"<?=$keep_days_30?>>30 <?=msg('DATE_DAYS')?></option>
      <option value="40day"<?=$keep_days_40?>>40 <?=msg('DATE_DAYS')?></option>
      <option value="50day"<?=$keep_days_50?>>50 <?=msg('DATE_DAYS')?></option>
      <option value="60day"<?=$keep_days_60?>>60 <?=msg('DATE_DAYS')?></option>
    </select>
    <label><?=msg('SETTINGS_314')?></label>
    <select name="low_space[]" <?=$eraser_select_disabled?>>
      <?=$eraser_select_error?>
      <option value="5%"<?=$low_space_5?>>5%</option>
      <option value="10%"<?=$low_space_10?>>10%</option>
      <option value="20%"<?=$low_space_20?>>20%</option>
    </select>
  </fieldset>