<?
  $_this_target = "LOCATION#L_SETTINGS_RECORD";
  if(!defined("_KVM_SETTING")){
    require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';
    $access_try_user = (empty($_SESSION['user_seq'])) ? "unknown" : $_SESSION['user_seq'];
    inputLog("WARNING", "L_SETTINGS", $_this_target, "K_ACCESS", $access_try_user, "CODE_SETTING_011", "");
    exit('<p style="font-size:24px; line-height:1.6; color:red;">ACCESS ERROR!</p>');
  }

  $istreamer_data = parse_ini_file($_istreamer_config_file,true,INI_SCANNER_RAW);

  $record_enable_yes = $record_enable_no = "";
  switch($istreamer_data['Record']['enable']){
    case "yes": $record_enable_yes = $selected; break;
    case "no": $record_enable_no = $selected; break;
  }

  $record_size = array();
  $record_size[$istreamer_data['Global']['Screen_Width']."_".$istreamer_data['Global']['Screen_Height']] = $selected;

  if(isset($_POST['record_enable']) || isset($_POST['record_screen_size'])){

    $_add_log_message = "";

    if(isset($_POST['record_enable']) && ($istreamer_data['Record']['enable'] != $_POST['record_enable'])){
      $_add_log_message .= ($_POST['record_enable'] == "yes") ? " * Record : off → on\n" : " * Record : on → off\n";
      $istreamer_data['Record']['enable'] = $_POST['record_enable'];
    }

    if(isset($_POST['record_screen_size'])){
      list($record_screen_width,$record_screen_height) = explode("|", $_POST['record_screen_size']);
      if($istreamer_data['Global']['Screen_Width'] != $record_screen_width || $istreamer_data['Global']['Screen_Height'] != $record_screen_height){
        $_add_log_message .= " * Record Screen Size : ".$istreamer_data['Global']['Screen_Width']."×".$istreamer_data['Global']['Screen_Height'].
                             " → ".$record_screen_width."×".$record_screen_height."\n";
        $istreamer_data['Global']['Screen_Width'] = $record_screen_width;
        $istreamer_data['Global']['Screen_Height'] = $record_screen_height;
      }
    }
    $istreamer_ini = new INIManager($_istreamer_config_file);
    $istreamer_ini->setINIData($istreamer_data);
    $istreamer_ini->writeINI_Section();
    unset($istreamer_ini);

    sleep(1);
    exec("killall istreamer");
    inputLog("INFO", $_this_location, $_this_target, "K_MODIFY", $_this_user, "CODE_SETTING_025", $_add_log_message);
    exit();
  }
?>
  <fieldset>
    <legend><?=msg('SETTINGS_301')?></legend>
    <div class="progress"><div class="bar" style="width:<?=$hdd_percent?>%;"></div></div>
    <p class="hdd_info">
      <?=msg('SETTINGS_302')?> <b style="color:#7CADE4"><?=$hdd_total?>GB</b> /
      <?=msg('SETTINGS_303')?> <b style="color:#9E011F"><?=$hdd_used?>GB(<?=$hdd_percent?>%)</b> /
      <?=msg('SETTINGS_316')?> <b style="color:#F39336"><?=$hdd_abailable?>GB(<?=100-$hdd_percent?>%)</b>
    </p>
  </fieldset>

  <fieldset>
<?php if($istreamer_data['Record']['enable'] == 'yes'){?>
    <legend><?=msg('SETTINGS_321')?> <span class="label green"><?=msg('SETTINGS_322')?></span></legend>
    <p><?=msg('SETTINGS_323')?></p>
<?php }else{?>
    <legend><?=msg('SETTINGS_321')?> <span class="label"><?=msg('SETTINGS_324')?></span></legend>
    <p><?=msg('SETTINGS_325')?></p>
<?php }?>
    <label><?=msg('SETTINGS_326')?></label>
    <select name="record_enable">
      <option value="yes"<?=$record_enable_yes?>><?=msg('SETTINGS_327')?></option>
      <option value="no"<?=$record_enable_no?>><?=msg('SETTINGS_328')?></option>
    </select>
    <!-- button id="system_start_record" type="submit" class="button run" data-check-change="no">stop record</button -->
  </fieldset>

  <fieldset class="last">
    <legend><?=msg('SETTINGS_329')?></legend>
    <p><?=msg('SETTINGS_330')?></p>
    <label><?=msg('SETTINGS_331')?></label>
    <select name="record_screen_size">
      <option value="640|480"<?=$record_size["640_480"]?>>640 × 480</option>
      <option value="800|600"<?=$record_size["800_600"]?>>800 × 600</option>
      <option value="960|600"<?=$record_size["960_600"]?>>960 × 600</option>
      <option value="1024|768"<?=$record_size["1024_768"]?>>1024 × 768</option>
      <option value="1088|612"<?=$record_size["1088_612"]?>>1088 × 612</option>
      <option value="1152|864"<?=$record_size["1152_864"]?>>1152 × 864</option>
      <option value="1280|720"<?=$record_size["1280_720"]?>>1280 × 720</option>
      <option value="1280|768"<?=$record_size["1280_768"]?>>1280 × 768</option>
      <option value="1280|800"<?=$record_size["1280_800"]?>>1280 × 800</option>
      <option value="1280|960"<?=$record_size["1280_960"]?>>1280 × 960</option>
      <option value="1280|1024"<?=$record_size["1280_1024"]?>>1280 × 1024</option>
      <option value="1360|768"<?=$record_size["1360_768"]?>>1360 × 768</option>
      <option value="1360|1024"<?=$record_size["1360_1024"]?>>1360 × 1024</option>
      <option value="1400|1050"<?=$record_size["1400_1050"]?>>1400 × 1050</option>
      <option value="1440|900"<?=$record_size["1440_900"]?>>1440 × 900</option>
      <option value="1600|900"<?=$record_size["1600_900"]?>>1600 × 900</option>
      <option value="1600|1024"<?=$record_size["1600_1024"]?>>1600 × 1024</option>
      <option value="1600|1200"<?=$record_size["1600_1200"]?>>1600 × 1200</option>
      <option value="1680|1050"<?=$record_size["1680_1050"]?>>1680 × 1050</option>
      <option value="1920|1080"<?=$record_size["1920_1080"]?>>1920 × 1080</option>
      <option value="1920|1200"<?=$record_size["1920_1200"]?>>1920 × 1200</option>
    </select>
  </fieldset>

<?php
/*
  <fieldset>
    <legend><?=msg("SETTINGS_707")?></legend>
    <p>
      <?=msg("SETTINGS_708A")?><br />
      <?=msg("SETTINGS_708B")?>
    </p>
    <a href="#emptyHDD" id="system_emptyHDD" type="button" class="button run"><?=msg("SETTINGS_709")?></a>
  </fieldset>

 */
?>
