<?php
require_once $_SERVER['DOCUMENT_ROOT'].'/devices/newest.php';
//if(certifyDB() == false) initDB("output");
$is_setup = setupCheck('boolean');
if(!$is_setup){
  forceSession();
  $firmware_info = getFirmwareVersion("current");
  $firmware_version = $firmware_info['current_version'];
?><!DOCTYPE HTML>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta charset="utf-8">
  <meta http-equiv="content-language" content="en">
  <meta name="robots" content="noindex, noarchive, nofollow">

  <title>Setup - RemoteKVM</title>
  <link rel="Shortcut Icon" type="image/ico" href="/favicon.ico">
  <link rel="stylesheet" media="screen, projection" type="text/css" href="/public/stylesheets/global.css">
  <style type="text/css">
    .floatWrap{position:relative;float:none;overflow:visible;*zoom:1;}.floatWrap:after{content:"";display:block;clear:both;height:0;visibility:hidden;}
    #setupForm{ width:620px; } #setupConfirmWindow{ display:none; width:100%; height:100%; position:absolute; top:0; left:0; background-color:#F0F1F5; padding:0; overflow:hidden; }
    #winContent{ position:absolute; top:50%;  margin-top:-260px; background-color:#F0F1F5; padding:30px; color:#717171; } #winContent h1{ color:#333; text-align:center; }
    #winContent dl{ font-size:16px; width:380px; margin:25px auto 36px; padding:21px 21px 6px; background-color:#fefeff; border-radius:7px; }
    #winContent dt,#winContent dd{ display:block; float:left; padding:0 10px 15px 0; }
    #winContent dt{ clear:left; width:160px; text-align:right; } #winContent dd{ width:200px; font-weight:bold; color:#AA551A; }
    #winContent p{ font-size:16px; text-align:center; margin-bottom:6px; }
    #winContent .button{ margin:0 14px; border-color: #1D97C3; background-color: #0DB1E8; background-image: -moz-linear-gradient(90deg, #1D97C3, #0DB1E8); background-image: -webkit-linear-gradient(90deg, #1D97C3, #0DB1E8); }
    input.error{ border-color: #99011E !important; box-shadow: 0px 0px 5px #99011E; }
    #device_name,#admin_id{ime-mode:disabled;}
  </style>
</head>
<body>
<div id="kvmWrap" class="bg">
  <div id="left">
    <div class="logo">
      <h1><a href="/">RemoteKVM</a></h1>
    </div>

    <div class="tip middle" style="margin-top: -220px;">
      <ul class="number">
        <li class="current">Input Basic Device Informations</li>
        <li>Check &amp; Setup Device</li>
        <li>Restart Device</li>
      </ul>
    </div>
    <?php include $_SERVER['DOCUMENT_ROOT'].'/_common/version.php'; ?>
  </div>
  <div id="content">

    <form action="/setup/apply.php" method="post" id="setupForm" class="simple" style="position:relative; padding-top:10%">
      <input name="setup" value="Y" type="hidden" />
      <input name="is_local" value="Y" type="hidden" />
      <input name="current_ip" value="<?=$local_dev_ip?>" type="hidden" />
      <input name="mac" value="<?=$local_dev_mac?>" type="hidden" />
      <input name="seq" value="<?=$local_dev_seq?>" type="hidden" />
      <input name="firmware" value="<?=$firmware_version?>" type="hidden" />

      <fieldset>
        <legend>Network Information Settings</legend>
        <p>Setting network information to use device.</p>
        <label>Device Name <strong>*</strong></label>
          <input type="text" name="name" value="" id="device_name" data-type="id" data-required="required" />
          <p class="hint">Only contain letters, numbers, '-' and '_'. (3~24 characters)<br>First Letter only can be Alphabet.</p>
        <label>Device IP <strong>*</strong></label>
          <input type="text" name="ip" value="<?=$local_dev_ip?>" id="device_ip" data-type="ip" data-required="required" />
          <p class="hint">Input valid IP address form.</p>
        <label>Default Gateway <strong>*</strong></label>
          <input type="text" name="gateway" value="<?=$local_dev_gateway?>" id="device_gw" data-type="ip" data-required="required" />
        <label>Subnet Mast <strong>*</strong></label>
          <input type="text" name="subnet" value="<?=$local_dev_subnet?>" id="device_sm" data-type="ip" data-required="required" />
        <label>Web Server Port <strong>*</strong></label>
          <input type="text" name="port" value="<?=$local_dev_port?>" id="device_wp" data-type="digit" data-required="required" />
        <br />
        <label>Default DNS</label>
          <input type="text" name="dns1" value="<?=$local_dev_dns1?>" id="device_dns1" data-type="ip" />
        <label>Secondary DNS</label>
          <input type="text" name="dns2" value="<?=$local_dev_dns2?>" id="device_dns2" data-type="ip" />
      </fieldset>

      <fieldset class="last">
        <legend>Admin User Settings</legend>
        <p>Setting super admin account.</p>
        <label>Admin ID <strong>*</strong></label>
          <input type="text" name="id" value="admin" id="admin_id" data-type="id" data-required="required" />
          <p class="hint">Only contain letters, numbers, '-' and '_'. (3~24 characters)<br>First Letter only can be Alphabet.</p>
        <label>Admin Password <strong>*</strong></label>
          <input type="password" name="pw" value="" id="admin_pw" data-type="pw" data-required="required" />
          <p class="hint">Password should be at least 4 characters.</p>
        <label>Confirm Password <strong>*</strong></label>
          <input type="password" name="pw2" value="" id="admin_pw2" data-type="pw" data-required="required" />
          <p class="hint">Input Password again</p>
        <label>Language</label>
          <select name="language" id="language">
            <option value="en-US"<?=$langEN?>><?=msg("ENGLISH")?></option>
            <option value="ko-KR"<?=$langKR?>><?=msg("KOREAN")?></option>
            <option value="ja-JP"<?=$langJP?>><?=msg("JAPANESE")?></option>
            <option value="zh-CN"<?=$langCN?>><?=msg("SIMCHINESE")?></option>
            <option value="zh-TW"<?=$langTW?>><?=msg("TRACHINESE")?></option>
          </select>
        <label>PC OS Type</label>
          <select name="pctype" id="pctype">
            <option value="0">Windows/Linux</option>
            <option value="1">Mac OSX</option>
          </select>
          <input type="hidden" id="lang" name="lang" />
      </fieldset>

      <div class="buttons">
        <label></label>
        <input type="button" class="button" id="setupSubmit" style="margin-left: 10px;" value="Submit" />
      </div>

      <div id="setupConfirmWindow" style="display:none;">
        <div id="winContent">
          <h1>Check Input Value</h1>
          <dl class="floatWrap">
            <dt>Device Name :</dt> <dd><span class="data_value" data-value="device_name">aa</span></dd>
            <dt>Device IP : </dt><dd><span class="data_value" data-value="device_ip">bb</span></dd>
            <dt>Gateway : </dt><dd><span class="data_value" data-value="device_gw">cc</span></dd>
            <dt>Subnet mask : </dt><dd><span class="data_value" data-value="device_sm">dd</span></dd>
            <dt>Web Server Port : </dt><dd><span class="data_value" data-value="device_wp">ee</span></dd>
            <dt>Default DNS : </dt><dd><span class="data_value" data-value="device_dns1">ff</span></dd>
            <dt>Secondary DNS : </dt><dd><span class="data_value" data-value="device_dns2">gg</span></dd>
            <dt>Admin ID : </dt><dd><span class="data_value" data-value="admin_id">hh</span></dd>
            <dt>Language : </dt><dd><span class="data_value" data-value="language">ii</span></dd>
            <dt>PC OS : </dt><dd><span class="data_value" data-value="pctype">ii</span></dd>
          </dl>
          <p>Are you sure set device this config?</p>
          <p class="buttonP">
            <input type="hidden" id="local_time" />
            <input type="submit" class="button yes" id="confirmYes" disabled="disabled" value="YES" />
            <input type="button" class="button no" id="confirmNo" value="NO" />
          </p>
        </div>
      </div>
    </form>

  </div>
</div>

<script type="text/javascript" src="/public/javascripts/jquery.min.js"></script>
<script type="text/javascript" src="/public/javascripts/kvm.base.js"></script>
<script type="text/javascript">
//<![CDATA[
(function($){
  $.extend(jQuery.easing,{
    def:'customEasing',
    customEasing:function(x,t,b,c,d){ return c*(t/=d)*t*t*t + b; }
  });
  var $form = $('#setupForm'),
      $formIpt = $form.find("input:text,input:password")
        .click(function(){$(this).removeClass("error")})
        .keydown(function(e){if(e.keyCode == 13) $('#setupSubmit').click()});
  $('#setupSubmit').click(function(){
    var is_validate = true;
    var highliting = [];
    var $confirmVal = $("#setupConfirmWindow span.data_value");
    $formIpt.removeClass("error");

    function validate(val,type,required){
      var ok = true,
          pattern = ({
            id: /^[a-z]{1}[\w-]{2,23}$/i,
            pw: /^[\w!@#\$%\^&\*\(\)-=\+~`\[\]\{\};:'",\.<>\/\\\|\?]{4,128}$/,
            digit: /^[\d]{1,8}$/,
            ip: /^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/
          })[type];
      if(required == "required") ok = (val == "" || val == null) ? false : pattern.test(val);
      else if(val != "") ok = pattern.test(val);
      return ok;
    }

    $.each($formIpt,function(){
      var ipt = $(this);
      if(validate(ipt.val(),ipt.attr("data-type"),ipt.attr("data-required")) == false){
        is_validate = false;
        highliting.push(ipt.attr("id"));
      }
    });

    if($("#admin_pw").val() != $("#admin_pw2").val()){
      highliting.push("admin_pw2");
      is_validate = false;
    }

    if(is_validate == true){
      $("#setupConfirmWindow span.data_value").each(function(){
        var thisTargetId = $(this).attr("data-value"),
            thisTarget = $("#"+thisTargetId),
            thisVar = (thisTarget.val() == "") ? "none" : thisTarget.val();
        if(thisTarget.get(0).tagName == "SELECT") thisVar = thisTarget.find("option[value='"+thisVar+"']").text();
        $(this).text(thisVar);
      })

      $('#setupConfirmWindow').slideDown(240,'customEasing',function(){
        $('#content').scrollTop(200);
      });
      $('#confirmYes').removeAttr('disabled');
    }else{
      $.each(highliting,function(){$("#"+this).addClass('error');});
      $form.animate({'margin-left':'113px'},49).animate({'margin-left':'132px'},57).animate({'margin-left':'120px'},72);
    }
  });

  $('#confirmNo').click(function(){
    $('#setupConfirmWindow').slideUp(240,'customEasing',function(){
      $('#content').scrollTop(0);
    });
    $('#confirmYes').attr('disabled','disabled');
  });

  $form.submit(function(){
    var dt = new Date(),
        local_time = (dt.getMonth()+1)+""+dt.getDate()+dt.getHours()+dt.getMinutes()+dt.getFullYear()+"."+dt.getSeconds();
    $("#local_time").attr('name','local_time').val(local_time);
    $("#lang").val($('#language').val());
    //console.log($form.serializeArray());
    //return false;
  })

})(jQuery);
//]]>
</script>
</body></html>
<?php
}else{
  //session_destroy();
  header('Location: /');
}
?>
