<?php
  /* *************************** *
   * KVM signin index file
   *
   ***************************** */
  define("_KVM_", true);
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_check.php';
  require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

  $_this_location = "L_SIGNIN";

  //로그인할때 장비 세팅 유무, ip검사
  setupCheck();
  ipCheck();

  //세션이 유효하면 본페이지로 이동
  if($session_ok) header('Location: /');

  $login_proc = true;
  $ua = getBrowser();
  $user_ip = $_SERVER['REMOTE_ADDR'];
  $user_platform = $ua['platform']." ".$ua['os_version'];
  $user_browser = $ua['browser']." ".$ua['version'];
  $login_try_count = isset($_POST["count"]) ? $_POST["count"] : 0;

  $current_id = $errMsg = "";
  //로그인 값이 넘어 왔으면 로그인 처리
  if(isset($_POST["user_id"])||isset($_POST["user_pw"])){
    $user_id = strtolower($_POST["user_id"]);
    $user_pw = $_POST["user_pw"];

    if (!trim($user_id)||!trim($user_pw)){
      $login_proc = false;
      $errMsg = msg("SIGNIN_110");
      $login_try_count++;
    }else{
      $user_pw = cryptPW($_POST["user_pw"]);
    }
  }else{
    $login_proc = false;
  }

  $kvmDB = new kvmDB();
  //로그인 처리
  if($login_proc){
    $rs = $kvmDB->getData("SELECT seq, id, pw, type, sessid FROM users_data where id = '".$user_id."' AND active = 'Y'");
    //아이디가 일치하면
    if($row = $rs->fetchArray()){
      //비번맞는가 검사하여 맞으면 변수 할당하여 세션처리
      if($user_pw == $row["pw"]){

        $_SESSION["user_id"] = $row["id"];
        $_SESSION["user_pw"] = $row["pw"];
        $_SESSION["user_seq"] = $row["seq"];
        $_SESSION["user_type"] = $row["type"];
        $_SESSION["last_refresh_time"] = time();
        $kvmDB->setData("UPDATE users_data SET sessid = '".session_id()."' WHERE seq = '".$row["seq"]."'");

        //디바이스 최신정보 갱신
        require_once $_SERVER['DOCUMENT_ROOT'].'/devices/newest.php';
        updateLocalDeviceInfoToDB();
        $login_seccess = true;

      }else{
        $errMsg = msg("SIGNIN_109");
        //$current_id = $user_id;
        $login_try_count++;
      }
    }else{
      $errMsg = msg("SIGNIN_108");
      $login_try_count++;
    }
  }

  unset($kvmDB);
  $current_id = isset($user_id) ? $user_id : "";

  $_add_log_message  = " * IP : ".$user_ip."\n";
  $_add_log_message .= " * OS : ".$user_platform."\n";
  $_add_log_message .= " * Browser : ".$user_browser."\n";

  if($login_try_count > 2){
    inputLog("WARNING", $_this_location, "", "K_PROCESS", "", "CODE_SIGNIN_002", $_add_log_message);
    $login_try_count = 0;
  }

  if(isset($login_seccess) && $login_seccess == true){
    //시간 세팅
    //if($_SESSION["user_type"] == 'super' && isset($_POST['local_time'])) exec("date ".$_POST['local_time']);
    inputLog("INFO", $_this_location, "", "K_PROCESS", $row["seq"], "CODE_SIGNIN_001", $_add_log_message);
    header('Location: /');
  }
?><!DOCTYPE HTML>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta charset="utf-8">
  <meta http-equiv="content-language" content="en">
  <meta name="robots" content="noindex, noarchive, nofollow">
  <meta name="viewport" content="width=990" />

  <title><?=msg('SIGNIN_101')?> - <?=$_SESSION["device_display_name"]?></title>
  <link rel="Shortcut Icon" type="image/ico" href="/favicon.ico">
  <link rel="stylesheet" media="screen, projection" type="text/css" href="/public/stylesheets/global.css">
</head>
<body class="<?=$_lang_code?>">
<div id="kvmWrap" class="bg">
  <div id="left">
    <div class="logo">
      <h1><a href="/">RemoteKVM</a></h1>
      <!-- span class="logo-subline"> is just a prototype</span -->
    </div>

    <div class="tip middle" style="margin-top: -200px;">
      <?=msg('SIGNIN_107A')?><br />
      <?=msg('SIGNIN_107B')?>
    </div>

    <?php include $_SERVER['DOCUMENT_ROOT'].'/_common/version.php'; ?>
  </div>
  <div id="content">

      <form id="signin-form" class="simple middle" style="position:absolute; top:33%;" method="post" action="/signin/index.php">
        <input type="hidden" name="count" value="<?=$login_try_count?>" />
        <fieldset class="last">
          <legend><?=msg('SIGNIN_101')?></legend>
          <p class="description">
             <?=msg('SIGNIN_102A')?><br />
             <?//=msg('SIGNIN_102B')?>
          </p>
          <label><?=msg('SIGNIN_103')?></label><input type="text" name="user_id" value="<?=$current_id?>" style="ime-mode:disabled;" />
          <label><?=msg('SIGNIN_104')?></label><input type="password" name="user_pw" />
          <p class="error"><?=$errMsg?></p>
          <!-- label></label><input type="checkbox" style="margin-right: 10px;" /><?=msg('SIGNIN_105A')?>
            <br />
            <?=msg('SIGNIN_105B')?><br / -->
        </fieldset>
        <div class="buttons">
          <label></label><button class="button" type="submit"><?=msg('SIGNIN_106')?></button>
        </div>
        <input type="hidden" id="local_time" />
      </form>

  </div>
</div>
<script type="text/javascript" src="/public/javascripts/jquery.min.js"></script>
<script type="text/javascript" src="/public/javascripts/kvm.base.js"></script>
<script type="text/javascript">
  $(function(){
    $("#signin-form").submit(function(){
      var dt = new Date();
      $("#local_time").attr('name','local_time').val((dt.getMonth()+1)+""+dt.getDate()+dt.getHours()+dt.getMinutes()+dt.getFullYear()+"."+dt.getSeconds());
    });
    $($('[name="user_id"]').val() == '' ? '[name="user_id"]' : '[name="user_pw"]').focus();
  })
</script>
</body></html>