<?php
/* ************************* *
 * User Index File
 * ************************* */
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/session_check.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/_common/base.php';

$seq = isset($_GET["seq"])? $_GET["seq"] : $_SESSION["user_seq"];

$cookie_name = 'user_order';
if(isset($_COOKIE[$cookie_name])){
  $orderby = $_COOKIE[$cookie_name];
}else{
  setCookie($cookie_name,'date',0,'/');
  $orderby = 'date';
}

$kvmDB = new kvmDB();
$selected = ' selected="selected"';

if($_SESSION['user_type'] != "admin" && $_SESSION['user_type'] != "super") exit();

if($_device_display_type == "ip"){
  $local_device_name = $_SERVER['SERVER_ADDR'];
  $local_device_name_tooltip = $_SESSION['device_name'];
}else{
  $local_device_name = $_SESSION['device_name'];
  $local_device_name_tooltip = $_SERVER['SERVER_ADDR'];
}

switch($_SESSION['user_type']){
  case 'super': $user_sql = "SELECT rowid, seq, id FROM users_data WHERE active = 'Y'"; break;
  case 'admin': $user_sql = "SELECT rowid, seq, id FROM users_data WHERE type <> 'super' AND active = 'Y'"; break;
  case 'user': $user_sql = "SELECT rowid, seq, id FROM users_data WHERE seq = '".$_SESSION['user_seq']."' AND active = 'Y'"; break;
}

if($orderby == 'name'){
  $user_sql .= ' ORDER BY id ASC';
}

$users = $kvmDB->getData($user_sql);


$devices = $kvmDB->getData("SELECT seq, name, ip4 FROM devices_data WHERE local <> 'Y' AND pending = '' AND active = 'Y'");
//해당유저정보
$user = $kvmDB->getData("SELECT rowid, seq, id, type FROM users_data WHERE seq = '".$seq."'");
$user_devices = $kvmDB->getData("SELECT di.seq, di.name ,di.ip4 FROM devices_data di, user_device_map dm
                                 WHERE di.seq = dm.device AND dm.user = '".$seq."' AND local = 'N' AND di.active = 'Y'");

$i = 0;
$innerText = "";
while($row = $users->fetchArray()){
  $user_current_class = ($row['seq']==$seq) ? 'current' : "";
  $user_signed_class = ($row['seq']==$_SESSION['user_seq']) ? ' signed' : "";
  $innerText .= '<li data-name="'.$row['id'].'" data-order="'.$row['rowid'].'" class="'.$user_current_class.$user_signed_class.'">';
  $innerText .= '<a href="/users/?seq='.$row['seq'].'&lang='.$_SESSION["language"].'" class="name">'.$row['id'].'</a><span class="state"></span>';
  $innerText .= '</li>';
  $i++;
}
?>

<div id="center">
  <? if($_SESSION['user_type'] != 'user'){ ?>
  <div id="sorting-options" data-cookieName="<?=$cookie_name?>">
    <button type="button" id="sort-by-date" class="<? if($orderby == 'name'){?>active<?}?>"><?=msg('BTN_ORDERBY_DATE')?></button>
    <button type="button" id="sort-by-name" class="<? if($orderby == 'date'){?>active<?}?>"><?=msg('BTN_ORDERBY_ID')?></button>
  </div>
  <?}?>

  <ul class="nav user">
    <?=$innerText?>
  </ul>
</div>

<div id="right" class="<?=($i>1) ? 'narrow' : 'wide'?>">
<?php
  if($row = $user->fetchArray()){
    if ($row['type'] == "super" || $row['seq'] == $_SESSION["user_seq"]) $delete_btn_display = 'style="display:none"';
    switch($row['type']){
      case "super": $type_option = '<option value="super" selected="selected">'.msg('USERS_111').'</option>'; break;
      case "admin": $type_option = '<option value="admin" selected="selected">'.msg('USERS_112').'</option> <option value="user">'.msg('USERS_113').'</option>'; break;
      case "user": $type_option = '<option value="admin">'.msg('USERS_112').'</option> <option value="user" selected="selected">'.msg('USERS_113').'</option>'; break;
    }

    //슈퍼유저랑 자기자신일땐 delete버튼 안나옴
    $delete_btn = '<a href="#removeItem" class="button remove" title="'.msg('USERS_121').'" tabindex="-1">'.msg('BTN_DELETE').'</a>';
    if($row['type'] == "super" || $row['seq'] == $_SESSION["user_seq"]){
      $delete_btn = '';
    }
?>
  <form action="/users/update.php" method="post" class="main" id="users">
    <input type="hidden" name="seq" value="<?=$row['seq']?>" />

    <fieldset>
      <legend><?=msg('USERS_101')?></legend>
      <p><?=msg('USERS_102')?></p>

      <label><?=msg('USERS_103')?> <strong>*</strong></label>
      <input name="id" value="<?=$row['id']?>" type="text" />
      <p class="hint"><?=msg('USERS_104')?></p>

      <label><?=msg('USERS_105')?> <strong class="required" style="display: none">*</strong></label>
      <input name="pw" type="password">
      <p class="hint"><?=msg('USERS_106')?></p>

      <label><?=msg('USERS_107')?> <strong class="required" style="display: none">*</strong></label>
      <input name="pw2" type="password">
    </fieldset>

    <fieldset class="last">
      <legend><?=msg('USERS_108')?></legend>
      <p><?=msg('USERS_109')?></p>

      <label><?=msg('USERS_110')?></label>
      <select id="account-type" name="type" >
        <?=$type_option?>
      </select>
    </fieldset>

    <fieldset class="last top" id="assigned" <? if($row['type'] == 'admin'||$row['type'] == 'super') echo 'style="display:none;"'; ?>>
      <label class="filename" title="Select Device"><?=msg('USERS_114')?> <strong>*</strong></label>
      <a href="#selectDevice" class="file"><?=msg('USERS_115')?></a>
      <p class="hint"><?=msg('USERS_116')?></p>

      <div class="accessable-devices">
        <div class="fixed access-device">
          <label title="<?=$local_device_name_tooltip?>" class="filename" style="width: auto;"><a href="#devices" class="goto-device"><?=$local_device_name?></a></label>
        </div>
<?php
       while($row_d = $user_devices->fetchArray()){
         if($_device_display_type == "ip"){
           $device_display_name = $row_d['ip4'];
           $device_display_name_tooltip = $row_d['name'];
         }else{
           $device_display_name = $row_d['name'];
           $device_display_name_tooltip = $row_d['ip4'];
         }
?>
        <div class="item access-device">
          <div class="toos">
            <!-- a href="#moveUpItem" tabindex="-1" title="Move Up" class="button-move-up">Up</a>
            <a href="#moveDownItem" tabindex="-1" title="Move Down" class="button-move-down">Down</a -->
            <a href="#removeDevice" tabindex="-1" title="Remove device?" class="button-del">Remove device</a>
          </div>
          <label title="<?=$device_display_name_tooltip?>" class="filename" style="width: auto;"><a href="#devices/<?=$row_d['name']?>" class="goto-device"><?=$device_display_name?></a></label>
          <input type="hidden" name="device_seq[]" value="<?=$row_d['seq']?>"/>
          <input type="hidden" name="device_name[]" value="<?=$row_d['name']?>"/>
        </div>
<?php
       }
?>
      </div>
    </fieldset>

    <div class="buttons">
      <a href="#saveItem" class="button save dim"><?=msg('BTN_SAVE')?></a>
      <?=$delete_btn?>
      <a href="#createItem" class="button create" style="display: none"><?=msg('BTN_CREATE')?></a>
      <a href="#cancelCreate" class="button cancel" style="display: none"><?=msg('BTN_CANCEL')?></a>
      <a href="#addItem" class="button add"><?=msg('USERS_118')?></a>
    </div>
  </form>
<?
  }
?>

  <div id="selector" style="display: none;" title="<?=msg('USERS_122')?>">
    <a href="#selectDevice" class="button-close">Close</a>
    <div>
  <?php
    while($row = $devices->fetchArray()){
      if($_device_display_type == "ip"){
        $device_display_name = $row['ip4'];
        $device_display_name_tooltip = $row['name'];
      }else{
        $device_display_name = $row['name'];
        $device_display_name_tooltip = $row['ip4'];
      }
  ?>
      <a href="#assignDevice" class="button-assign-device" id="seq_<?=$row['seq']?>" title="<?=$device_display_name_tooltip?>"><?=msg('USERS_117')?></a>
      <p title="<?=$device_display_name_tooltip?>"><?=$device_display_name?></p>
  <?php
    }
  ?>
    </div>
  </div>

</div>
<?php
  unset($kvmDB);
?>
